<?php
/** Adminer Editor - Compact database editor
* @link https://www.adminer.org/
* @author Jakub Vrana, https://www.vrana.cz/
* @copyright 2009 Jakub Vrana
* @license https://www.apache.org/licenses/LICENSE-2.0 Apache License, Version 2.0
* @license https://www.gnu.org/licenses/gpl-2.0.html GNU General Public License, version 2 (one or other)
* @version 4.8.4
*/function
adminer_errors($Bb,$Cb){return!!preg_match('~^(Trying to access array offset on( value of type)? null|Undefined array key)~',$Cb);}error_reporting(6135);set_error_handler('adminer_errors',E_WARNING);$Ob=!preg_match('~^(unsafe_raw)?$~',ini_get("filter.default"));if($Ob||ini_get("filter.default_flags")){foreach(array('_GET','_POST','_COOKIE','_SERVER')as$W){$Ue=filter_input_array(constant("INPUT$W"),FILTER_UNSAFE_RAW);if($Ue)$$W=$Ue;}}if(function_exists("mb_internal_encoding"))mb_internal_encoding("8bit");function
connection(){global$f;return$f;}function
adminer(){global$b;return$b;}function
version(){global$ca;return$ca;}function
idf_unescape($pc){if(!preg_match('~^[`\'"[]~',$pc))return$pc;$Gc=substr($pc,-1);return
str_replace($Gc.$Gc,$Gc,substr($pc,1,-1));}function
escape_string($W){return
substr(q($W),1,-1);}function
number($W){return
preg_replace('~[^0-9]+~','',$W);}function
number_type(){return'((?<!o)int(?!er)|numeric|real|float|double|decimal|money)';}function
remove_slashes($Hd,$Ob=false){if(function_exists("get_magic_quotes_gpc")&&get_magic_quotes_gpc()){while(list($x,$W)=each($Hd)){foreach($W
as$Ac=>$V){unset($Hd[$x][$Ac]);if(is_array($V)){$Hd[$x][stripslashes($Ac)]=$V;$Hd[]=&$Hd[$x][stripslashes($Ac)];}else$Hd[$x][stripslashes($Ac)]=($Ob?$V:stripslashes($V));}}}}function
bracket_escape($pc,$ta=false){static$Le=array(':'=>':1',']'=>':2','['=>':3','"'=>':4');return
strtr($pc,($ta?array_flip($Le):$Le));}function
min_version($cf,$Qc="",$g=null){global$f;if(!$g)$g=$f;$ee=$g->server_info;if($Qc&&preg_match('~([\d.]+)-MariaDB~',$ee,$A)){$ee=$A[1];$cf=$Qc;}return(version_compare($ee,$cf)>=0);}function
charset($f){return(min_version("5.5.3",0,$f)?"utf8mb4":"utf8");}function
script($ke,$Ke="\n"){return"<script".nonce().">$ke</script>$Ke";}function
script_src($Ye){return"<script src='".h($Ye)."'".nonce()."></script>\n";}function
nonce(){return' nonce="'.get_nonce().'"';}function
target_blank(){return' target="_blank" rel="noreferrer noopener"';}function
h($R){return
str_replace("\0","&#0;",htmlspecialchars($R,ENT_QUOTES,'utf-8'));}function
nl_br($R){return
str_replace("\n","<br>",$R);}function
checkbox($E,$X,$Da,$Dc="",$jd="",$Ga="",$Ec=""){$L="<input type='checkbox' name='$E' value='".h($X)."'".($Da?" checked":"").($Ec?" aria-labelledby='$Ec'":"").">".($jd?script("qsl('input').onclick = function () { $jd };",""):"");return($Dc!=""||$Ga?"<label".($Ga?" class='$Ga'":"").">$L".h($Dc)."</label>":$L);}function
optionlist($F,$Zd=null,$af=false){$L="";foreach($F
as$Ac=>$V){$od=array($Ac=>$V);if(is_array($V)){$L.='<optgroup label="'.h($Ac).'">';$od=$V;}foreach($od
as$x=>$W)$L.='<option'.($af||is_string($x)?' value="'.h($x).'"':'').(($af||is_string($x)?(string)$x:$W)===$Zd?' selected':'').'>'.h($W);if(is_array($V))$L.='</optgroup>';}return$L;}function
html_select($E,$F,$X="",$id=true,$Ec=""){if($id)return"<select name='".h($E)."'".($Ec?" aria-labelledby='$Ec'":"").">".optionlist($F,$X)."</select>".(is_string($id)?script("qsl('select').onchange = function () { $id };",""):"");$L="";foreach($F
as$x=>$W)$L.="<label><input type='radio' name='".h($E)."' value='".h($x)."'".($x==$X?" checked":"").">".h($W)."</label>";return$L;}function
select_input($c,$F,$X="",$id="",$Ad=""){$ye=($F?"select":"input");return"<$ye$c".($F?"><option value=''>$Ad".optionlist($F,$X,true)."</select>":" size='10' value='".h($X)."' placeholder='$Ad'>").($id?script("qsl('$ye').onchange = $id;",""):"");}function
confirm($C="",$ae="qsl('input')"){return
script("$ae.onclick = function () { return confirm('".($C?js_escape($C):'Är du säker?')."'); };","");}function
print_fieldset($s,$Ic,$ef=false){echo"<fieldset><legend>","<a href='#fieldset-$s'>$Ic</a>",script("qsl('a').onclick = partial(toggle, 'fieldset-$s');",""),"</legend>","<div id='fieldset-$s'".($ef?"":" class='hidden'").">\n";}function
generate_linksbar($Mc){$Nc="<p class='links'>";foreach($Mc
as$x=>$z){if($x!==key(array_keys($Mc)))$Nc.="<span class='separator'>|</span>";$Nc.=$z;}$Nc.="</p>";return$Nc;}function
bold($_a,$Ga=""){return($_a?" class='active $Ga'":($Ga?" class='$Ga'":""));}function
odd($L=' class="odd"'){static$r=0;if(!$L)$r=-1;return($r++%2?$L:'');}function
js_escape($R){return
addcslashes($R,"\r\n'\\/");}function
json_row($x,$W=null){static$Pb=true;if($Pb)echo"{";if($x!=""){echo($Pb?"":",")."\n\t\"".addcslashes($x,"\r\n\t\"\\/").'": '.($W!==null?'"'.addcslashes($W,"\r\n\"\\/").'"':'null');$Pb=false;}else{echo"\n}\n";$Pb=true;}}function
ini_bool($uc){$W=ini_get($uc);return(preg_match('~^(on|true|yes)$~i',$W)||(int)$W);}function
sid(){static$L;if($L===null)$L=(SID&&!($_COOKIE&&ini_bool("session.use_cookies")));return$L;}function
set_password($Y,$P,$U,$I){$_SESSION["pwds"][$Y][$P][$U]=($_COOKIE["adminer_key"]&&is_string($I)?array(encrypt_string($I,$_COOKIE["adminer_key"])):$I);}function
get_password(){$L=get_session("pwds");if(is_array($L))$L=($_COOKIE["adminer_key"]?decrypt_string($L[0],$_COOKIE["adminer_key"]):false);return$L;}function
q($R){global$f;return$f->quote($R);}function
get_vals($J,$d=0){global$f;$L=array();$K=$f->query($J);if(is_object($K)){while($M=$K->fetch_row())$L[]=$M[$d];}return$L;}function
get_key_vals($J,$g=null,$he=true){global$f;if(!is_object($g))$g=$f;$L=array();$K=$g->query($J);if(is_object($K)){while($M=$K->fetch_row()){if($he)$L[$M[0]]=$M[1];else$L[]=$M[0];}}return$L;}function
get_rows($J,$g=null,$j="<p class='error'>"){global$f;$Sa=(is_object($g)?$g:$f);$L=array();$K=$Sa->query($J);if(is_object($K)){while($M=$K->fetch_assoc())$L[]=$M;}elseif(!$K&&!is_object($g)&&$j&&defined("PAGE_HEADER"))echo$j.error()."\n";return$L;}function
unique_array($M,$u){foreach($u
as$t){if(preg_match("~PRIMARY|UNIQUE~",$t["type"])){$L=array();foreach($t["columns"]as$x){if(!isset($M[$x]))continue
2;$L[$x]=$M[$x];}return$L;}}}function
escape_key($x){if(preg_match('(^([\w(]+)('.str_replace("_",".*",preg_quote(idf_escape("_"))).')([ \w)]+)$)',$x,$A))return$A[1].idf_escape(idf_unescape($A[2])).$A[3];return
idf_escape($x);}function
where($Z,$l=array()){global$f,$w;$L=array();foreach((array)$Z["where"]as$x=>$W){$x=bracket_escape($x,1);$d=escape_key($x);$L[]=$d.($w=="sql"&&is_numeric($W)&&preg_match('~\.~',$W)?" LIKE ".q($W):($w=="mssql"?" LIKE ".q(preg_replace('~[_%[]~','[\0]',$W)):" = ".unconvert_field($l[$x],q($W))));if($w=="sql"&&preg_match('~char|text~',$l[$x]["type"]??null)&&preg_match("~[^ -@]~",$W))$L[]="$d = ".q($W)." COLLATE ".charset($f)."_bin";}foreach((array)$Z["null"]as$x)$L[]=escape_key($x)." IS NULL";return
implode(" AND ",$L);}function
where_check($W,$l=array()){parse_str($W,$Ca);remove_slashes(array(&$Ca));return
where($Ca,$l);}function
where_link($r,$d,$X,$ld="="){return"&where%5B$r%5D%5Bcol%5D=".urlencode($d)."&where%5B$r%5D%5Bop%5D=".urlencode(($X!==null?$ld:"IS NULL"))."&where%5B$r%5D%5Bval%5D=".urlencode($X);}function
convert_fields($e,$l,$O=array()){$L="";foreach($e
as$x=>$W){if($O&&!in_array(idf_escape($x),$O))continue;$oa=convert_field($l[$x]);if($oa)$L.=", $oa AS ".idf_escape($x);}return$L;}function
cookie($E,$X,$Lc=2592000){global$aa;return
header("Set-Cookie: $E=".urlencode($X).($Lc?"; expires=".gmdate("D, d M Y H:i:s",time()+$Lc)." GMT":"")."; path=".preg_replace('~\?.*~','',$_SERVER["REQUEST_URI"]).($aa?"; secure":"")."; HttpOnly; SameSite=lax",false);}function
restart_session(){if(!ini_bool("session.use_cookies"))session_start();}function
stop_session($Sb=false){$Ze=ini_bool("session.use_cookies");if(!$Ze||$Sb){session_write_close();if($Ze&&@ini_set("session.use_cookies",false)===false)session_start();}}function&get_session($x){return$_SESSION[$x][DRIVER][SERVER][$_GET["username"]];}function
set_session($x,$W){$_SESSION[$x][DRIVER][SERVER][$_GET["username"]]=$W;}function
auth_url($Y,$P,$U,$h=null){global$ob;preg_match('~([^?]*)\??(.*)~',remove_from_uri(implode("|",array_keys($ob))."|username|".($h!==null?"db|":"").session_name()),$A);return"$A[1]?".(sid()?SID."&":"").($Y!="server"||$P!=""?urlencode($Y)."=".urlencode($P)."&":"")."username=".urlencode($U).($h!=""?"&db=".urlencode($h):"").($A[2]?"&$A[2]":"");}function
is_ajax(){return($_SERVER["HTTP_X_REQUESTED_WITH"]=="XMLHttpRequest");}function
redirect($_,$C=null){if($C!==null){restart_session();$_SESSION["messages"][preg_replace('~^[^?]*~','',($_!==null?$_:$_SERVER["REQUEST_URI"]))][]=$C;}if($_!==null){if($_=="")$_=".";header("Location: $_");exit;}}function
query_redirect($J,$_,$C,$Od=true,$Gb=true,$Jb=false,$Ce=""){global$f,$j,$b;if($Gb){$me=microtime(true);$Jb=!$f->query($J);$Ce=format_time($me);}$le="";if($J)$le=$b->messageQuery($J,$Ce,$Jb);if($Jb){$j=error().$le.script("messagesPrint();");return
false;}if($Od)redirect($_,$C.$le);return
true;}function
queries($J){global$f;static$Jd=array();static$me;if(!$me)$me=microtime(true);if($J===null)return
array(implode("\n",$Jd),format_time($me));$Jd[]=(preg_match('~;$~',$J)?"DELIMITER ;;\n$J;\nDELIMITER ":$J).";";return$f->query($J);}function
apply_queries($J,$xe,$Db='table'){foreach($xe
as$S){if(!queries("$J ".$Db($S)))return
false;}return
true;}function
queries_redirect($_,$C,$Od){list($Jd,$Ce)=queries(null);return
query_redirect($Jd,$_,$C,$Od,false,!$Od,$Ce);}function
format_time($me){return
sprintf('%.3f s',max(0,microtime(true)-$me));}function
relative_uri(){return
str_replace(":","%3a",preg_replace('~^[^?]*/([^?]*)~','\1',$_SERVER["REQUEST_URI"]));}function
remove_from_uri($ud=""){return
substr(preg_replace("~(?<=[?&])($ud".(SID?"":"|".session_name()).")=[^&]*&~",'',relative_uri()."&"),0,-1);}function
pagination($H,$ab){return" ".($H==$ab?$H+1:'<a href="'.h(remove_from_uri("page").($H?"&page=$H".($_GET["next"]?"&next=".urlencode($_GET["next"]):""):"")).'">'.($H+1)."</a>");}function
get_file($x,$eb=false){$Mb=$_FILES[$x];if(!$Mb)return
null;foreach($Mb
as$x=>$W)$Mb[$x]=(array)$W;$L='';foreach($Mb["error"]as$x=>$j){if($j)return$j;$E=$Mb["name"][$x];$Ie=$Mb["tmp_name"][$x];$Ua=file_get_contents($eb&&preg_match('~\.gz$~',$E)?"compress.zlib://$Ie":$Ie);if($eb){$me=substr($Ua,0,3);if(function_exists("iconv")&&preg_match("~^\xFE\xFF|^\xFF\xFE~",$me,$Pd))$Ua=iconv("utf-16","utf-8",$Ua);elseif($me=="\xEF\xBB\xBF")$Ua=substr($Ua,3);$L.=$Ua."\n\n";}else$L.=$Ua;}return$L;}function
upload_error($j){$Tc=($j==UPLOAD_ERR_INI_SIZE?ini_get("upload_max_filesize"):0);return($j?'Det går inte add ladda upp filen.'.($Tc?" ".sprintf('Högsta tillåtna storlek är %sB.',$Tc):""):'Filen finns inte.');}function
repeat_pattern($yd,$Jc){return
str_repeat("$yd{0,65535}",$Jc/65535)."$yd{0,".($Jc%65535)."}";}function
is_utf8($W){return(preg_match('~~u',$W)&&!preg_match('~[\0-\x8\xB\xC\xE-\x1F]~',$W));}function
shorten_utf8($R,$Jc=80,$re=""){if(!preg_match("(^(".repeat_pattern("[\t\r\n -\x{10FFFF}]",$Jc).")($)?)u",$R,$A))preg_match("(^(".repeat_pattern("[\t\r\n -~]",$Jc).")($)?)",$R,$A);return
h($A[1]).$re.(isset($A[2])?"":"<i>…</i>");}function
format_number($W){return
strtr(number_format($W,0,".",','),preg_split('~~u','0123456789',-1,PREG_SPLIT_NO_EMPTY));}function
friendly_url($W){return
preg_replace('~[^a-z0-9_]~i','-',$W);}function
hidden_fields($Hd,$rc=array(),$Dd=''){$L=false;foreach($Hd
as$x=>$W){if(!in_array($x,$rc)){if(is_array($W))hidden_fields($W,array(),$x);else{$L=true;echo'<input type="hidden" name="'.h($Dd?$Dd."[$x]":$x).'" value="'.h($W).'">';}}}return$L;}function
hidden_fields_get(){echo(sid()?'<input type="hidden" name="'.session_name().'" value="'.h(session_id()).'">':''),(SERVER!==null?'<input type="hidden" name="'.DRIVER.'" value="'.h(SERVER).'">':""),'<input type="hidden" name="username" value="'.h($_GET["username"]).'">';}function
table_status1($S,$Kb=false){$L=table_status($S,$Kb);return($L?$L:array("Name"=>$S));}function
column_foreign_keys($S){global$b;$L=array();foreach($b->foreignKeys($S)as$n){foreach($n["source"]as$W)$L[$W][]=$n;}return$L;}function
enum_input($Oe,$c,$k,$X,$yb=null){global$b;preg_match_all("~'((?:[^']|'')*)'~",$k["length"],$B);$L=($yb!==null?"<label><input type='$Oe'$c value='$yb'".((is_array($X)?in_array($yb,$X):$X===0)?" checked":"")."><i>".'tom'."</i></label>":"");foreach($B[1]as$r=>$W){$W=stripcslashes(str_replace("''","'",$W));$Da=(is_int($X)?$X==$r+1:(is_array($X)?in_array($r+1,$X):$X===$W));$L.=" <label><input type='$Oe'$c value='".($r+1)."'".($Da?' checked':'').'>'.h($b->editVal($W,$k)).'</label>';}return$L;}function
input($k,$X,$p){global$Pe,$b,$w;$E=h(bracket_escape($k["field"]));echo"<td class='function'>";if(is_array($X)&&!$p){$na=array($X);if(version_compare(PHP_VERSION,5.4)>=0)$na[]=JSON_PRETTY_PRINT;$X=call_user_func_array('json_encode',$na);$p="json";}$Rd=($w=="mssql"&&$k["auto_increment"]);if($Rd&&!$_POST["save"])$p=null;$ac=(isset($_GET["select"])||$Rd?array("orig"=>'original'):array())+$b->editFunctions($k);$c=" name='fields[$E]'";if($k["type"]=="enum")echo
h($ac[""])."<td>".$b->editInput($_GET["edit"],$k,$c,$X);else{$gc=(in_array($p,$ac)||isset($ac[$p]));echo(count($ac)>1?"<select name='function[$E]'>".optionlist($ac,$p===null||$gc?$p:"")."</select>".on_help("getTarget(event).value.replace(/^SQL\$/, '')",1).script("qsl('select').onchange = functionChange;",""):h(reset($ac))).'<td>';$wc=$b->editInput($_GET["edit"],$k,$c,$X);if($wc!="")echo$wc;elseif(preg_match('~bool~',$k["type"]))echo"<input type='hidden'$c value='0'>"."<input type='checkbox'".(preg_match('~^(1|t|true|y|yes|on)$~i',$X)?" checked='checked'":"")."$c value='1'>";elseif($k["type"]=="set"){preg_match_all("~'((?:[^']|'')*)'~",$k["length"],$B);foreach($B[1]as$r=>$W){$W=stripcslashes(str_replace("''","'",$W));$Da=(is_int($X)?($X>>$r)&1:in_array($W,explode(",",$X),true));echo" <label><input type='checkbox' name='fields[$E][$r]' value='".(1<<$r)."'".($Da?' checked':'').">".h($b->editVal($W,$k)).'</label>';}}elseif(preg_match('~blob|bytea|raw|file~',$k["type"])&&ini_bool("file_uploads"))echo"<input type='file' name='fields-$E'>";elseif(($_e=preg_match('~text|lob|memo~i',$k["type"]))||preg_match("~\n~",$X)){if($_e&&$w!="sqlite")$c.=" cols='50' rows='12'";else{$N=min(12,substr_count($X,"\n")+1);$c.=" cols='30' rows='$N'".($N==1?" style='height: 1.2em;'":"");}echo"<textarea$c>".h($X).'</textarea>';}elseif($p=="json"||preg_match('~^jsonb?$~',$k["type"]))echo"<textarea$c cols='50' rows='12' class='jush-js'>".h($X).'</textarea>';else{$Vc=(!preg_match('~int~',$k["type"])&&preg_match('~^(\d+)(,(\d+))?$~',$k["length"],$A)?((preg_match("~binary~",$k["type"])?2:1)*$A[1]+($A[3]?1:0)+($A[2]&&!$k["unsigned"]?1:0)):($Pe[$k["type"]]?$Pe[$k["type"]]+($k["unsigned"]?0:1):0));if($w=='sql'&&min_version(5.6)&&preg_match('~time~',$k["type"]))$Vc+=7;echo"<input".((!$gc||$p==="")&&preg_match('~(?<!o)int(?!er)~',$k["type"])&&!preg_match('~\[\]~',$k["full_type"])?" type='number'":"")." value='".h($X)."'".($Vc?" data-maxlength='$Vc'":"").(preg_match('~char|binary~',$k["type"])&&$Vc>20?" size='40'":"")."$c>";}echo$b->editHint($_GET["edit"],$k,$X);$Pb=0;foreach($ac
as$x=>$W){if($x===""||!$W)break;$Pb++;}if($Pb)echo
script("mixin(qsl('td'), {onchange: partial(skipOriginal, $Pb), oninput: function () { this.onchange(); }});");}}function
process_input($k){global$b,$i;$pc=bracket_escape($k["field"]);$p=$_POST["function"][$pc]??null;$X=$_POST["fields"][$pc];if($k["type"]=="enum"){if($X==-1)return
false;if($X=="")return"NULL";return+$X;}if($k["auto_increment"]&&$X=="")return
null;if($p=="orig")return(preg_match('~^CURRENT_TIMESTAMP~i',$k["on_update"])?idf_escape($k["field"]):false);if($p=="NULL")return"NULL";if($k["type"]=="set")return
array_sum((array)$X);if($p=="json"){$p="";$X=json_decode($X,true);if(!is_array($X))return
false;return$X;}if(preg_match('~blob|bytea|raw|file~',$k["type"])&&ini_bool("file_uploads")){$Mb=get_file("fields-$pc");if(!is_string($Mb))return
false;return$i->quoteBinary($Mb);}return$b->processInput($k,$X,$p);}function
fields_from_edit(){global$i;$L=array();foreach((array)$_POST["field_keys"]as$x=>$W){if($W!=""){$W=bracket_escape($W);$_POST["function"][$W]=$_POST["field_funs"][$x];$_POST["fields"][$W]=$_POST["field_vals"][$x];}}foreach((array)$_POST["fields"]as$x=>$W){$E=bracket_escape($x,1);$L[$E]=array("field"=>$E,"privileges"=>array("insert"=>1,"update"=>1),"null"=>1,"auto_increment"=>($x==$i->primary),);}return$L;}function
search_tables(){global$b,$f;$_GET["where"][0]["val"]=$_POST["query"];$ce="<ul>\n";foreach(table_status('',true)as$S=>$we){$E=$b->tableName($we);if(isset($we["Engine"])&&$E!=""&&(!$_POST["tables"]||in_array($S,$_POST["tables"]))){$K=$f->query("SELECT".limit("1 FROM ".table($S)," WHERE ".implode(" AND ",$b->selectSearchProcess(fields($S),array())),1));if(!$K||$K->fetch_row()){$Fd="<a href='".h(ME."select=".urlencode($S)."&where[0][op]=".urlencode($_GET["where"][0]["op"])."&where[0][val]=".urlencode($_GET["where"][0]["val"]))."'>$E</a>";echo"$ce<li>".($K?$Fd:"<p class='error'>$Fd: ".error())."\n";$ce="";}}}echo($ce?"<p class='message'>".'Inga tabeller.':"</ul>")."\n";}function
dump_headers($oc,$Yc=false){global$b;$L=$b->dumpHeaders($oc,$Yc);$rd=$_POST["output"];if($rd!="text")header("Content-Disposition: attachment; filename=".$b->dumpFilename($oc).".$L".($rd!="file"&&preg_match('~^[0-9a-z]+$~',$rd)?".$rd":""));session_write_close();ob_flush();flush();return$L;}function
dump_csv($M){foreach($M
as$x=>$W){if(preg_match('~["\n,;\t]|^0|\.\d*0$~',$W)||$W==="")$M[$x]='"'.str_replace('"','""',$W).'"';}echo
implode(($_POST["format"]=="csv"?",":($_POST["format"]=="tsv"?"\t":";")),$M)."\r\n";}function
apply_sql_function($p,$d){return($p?($p=="unixepoch"?"DATETIME($d, '$p')":($p=="count distinct"?"COUNT(DISTINCT ":strtoupper("$p("))."$d)"):$d);}function
get_temp_dir(){$L=ini_get("upload_tmp_dir");if(!$L){if(function_exists('sys_get_temp_dir'))$L=sys_get_temp_dir();else{$m=@tempnam("","");if(!$m)return
false;$L=dirname($m);unlink($m);}}return$L;}function
file_open_lock($m){$o=@fopen($m,"r+");if(!$o){$o=@fopen($m,"w");if(!$o)return;chmod($m,0660);}flock($o,LOCK_EX);return$o;}function
file_write_unlock($o,$bb){rewind($o);fwrite($o,$bb);ftruncate($o,strlen($bb));flock($o,LOCK_UN);fclose($o);}function
password_file($Wa){$m=get_temp_dir()."/adminer.key";$L=@file_get_contents($m);if($L||!$Wa)return$L;$o=@fopen($m,"w");if($o){chmod($m,0660);$L=rand_string();fwrite($o,$L);fclose($o);}return$L;}function
rand_string(){return
md5(uniqid(mt_rand(),true));}function
select_value($W,$z,$k,$Ae){global$b;if(is_array($W)){$L="";foreach($W
as$Ac=>$V)$L.="<tr>".($W!=array_values($W)?"<th>".h($Ac):"")."<td>".select_value($V,$z,$k,$Ae);return"<table cellspacing='0'>$L</table>";}if(!$z)$z=$b->selectLink($W,$k);if($z===null){if(is_mail($W))$z="mailto:$W";if(is_url($W))$z=$W;}$L=$b->editVal($W,$k);if($L!==null){if(!is_utf8($L))$L="\0";elseif($Ae!=""&&is_shortable($k))$L=shorten_utf8($L,max(0,+$Ae));else$L=h($L);}return$b->selectVal($L,$z,$k,$W);}function
is_mail($vb){$pa='[-a-z0-9!#$%&\'*+/=?^_`{|}~]';$nb='[[:alnum:]](?:[-[:alnum:]]{0,61}[[:alnum:]])';$yd="$pa+(?:\\.$pa+)*@(?:$nb?\\.)+$nb";return
is_string($vb)&&preg_match("(^$yd(?:,\\s*$yd)*\$)i",$vb);}function
is_url($R){return(bool)preg_match('~^
			https?://                 # scheme
			(?:
				# IPv6 in square brackets
				\[(?:
					(?:[[:xdigit:]]{1,4}:){7}[[:xdigit:]]{1,4} |             # 1:2:3:4:5:6:7:8
					(?:[[:xdigit:]]{1,4}:){1,7}: |                           # 1::                             1:2:3:4:5:6:7::
					(?:[[:xdigit:]]{1,4}:){1,6}:[[:xdigit:]]{1,4} |          # 1::8            1:2:3:4:5:6::8  1:2:3:4:5:6::8
					(?:[[:xdigit:]]{1,4}:){1,5}(?::[[:xdigit:]]{1,4}){1,2} | # 1::7:8          1:2:3:4:5::7:8  1:2:3:4:5::8
					(?:[[:xdigit:]]{1,4}:){1,4}(?::[[:xdigit:]]{1,4}){1,3} | # 1::6:7:8        1:2:3:4::6:7:8  1:2:3:4::8
					(?:[[:xdigit:]]{1,4}:){1,3}(?::[[:xdigit:]]{1,4}){1,4} | # 1::5:6:7:8      1:2:3::5:6:7:8  1:2:3::8
					(?:[[:xdigit:]]{1,4}:){1,2}(?::[[:xdigit:]]{1,4}){1,5} | # 1::4:5:6:7:8    1:2::4:5:6:7:8  1:2::8
					[[:xdigit:]]{1,4}:(?::[[:xdigit:]]{1,4}){1,6} |          # 1::3:4:5:6:7:8  1::3:4:5:6:7:8  1::8
					:(?::[[:xdigit:]]{1,4}){1,7} |                           # ::2:3:4:5:6:7:8 ::2:3:4:5:6:7:8 ::8
					fe80:(?::[[:xdigit:]]{0,4}){0,4}%[[:alnum:]]+ |          # fe80::7:8%eth0  fe80::7:8%1     (link-local IPv6 addresses with zone index)
					::(?:ffff(?::0{1,4})?:)?
						(?:(?:25[0-5]|(?:2[0-4]|1?[0-9])?[0-9])\.){3}
						(?:25[0-5]|(?:2[0-4]|1?[0-9])?[0-9])
						(?<!\b0\.0\.0\.0) |                                  # ::255.255.255.255  ::ffff:255.255.255.255 ::ffff:0:255.255.255.255  (IPv4-mapped IPv6 addresses and IPv4-translated addresses)
					(?:[[:xdigit:]]{1,4}:){1,4}:
						(?:(?:25[0-5]|(?:2[0-4]|1?[0-9])?[0-9])\.){3}
						(?:25[0-5]|(?:2[0-4]|1?[0-9])?[0-9])
						(?<!\b0\.0\.0\.0)                                    # 2001:db8:3:4::192.0.2.33  64:ff9b::192.0.2.33 (IPv4-Embedded IPv6 Address)
				)\] |
				# IPv4
				(?:(?:25[0-5]|(?:2[0-4]|1?[0-9])?[0-9])\.){3}
					(?:25[0-5]|(?:2[0-4]|1?[0-9])?[0-9])
					(?<!\b0\.0\.0\.0) |                                      # 0.0.0.0 excluded for URLs
				# domain
				[_[:alnum:]](?:[-_[:alnum:]]{0,61}[_[:alnum:]])?
					(?:\.[_[:alnum:]](?:[-_[:alnum:]]{0,61}[_[:alnum:]])?)*
			)                         # host
			(?::(?:[1-9]\d{0,3})?\d)? # port
			(?:/[^\s?\#]*)?           # path
			(?:\?[^\s\#]*)?           # query
			(?:\#\S*)?                # fragment
			$~xi',$R);}function
is_shortable($k){return
preg_match('~char|text|json|lob|geometry|point|linestring|polygon|string|bytea~',$k["type"]??null);}function
count_rows($S,$Z,$v,$q){global$w;$J=" FROM ".table($S).($Z?" WHERE ".implode(" AND ",$Z):"");return($v&&($w=="sql"||count($q)==1)?"SELECT COUNT(DISTINCT ".implode(", ",$q).")$J":"SELECT COUNT(*)".($v?" FROM (SELECT 1$J GROUP BY ".implode(", ",$q).") x":$J));}function
slow_query($J){global$b,$Je,$i;$h=$b->database();$De=$b->queryTimeout();$je=$i->slowQuery($J,$De);if(!$je&&support("kill")&&is_object($g=connect())&&($h==""||$g->select_db($h))){$Cc=$g->result(connection_id());echo'<script',nonce(),'>
var timeout = setTimeout(function () {
	ajax(\'',js_escape(ME),'script=kill\', function () {
	}, \'kill=',$Cc,'&token=',$Je,'\');
}, ',1000*$De,');
</script>
';}else$g=null;ob_flush();flush();$L=@get_key_vals(($je?$je:$J),$g,false);if($g){echo
script("clearTimeout(timeout);");ob_flush();flush();}return$L;}function
get_token(){$Md=rand(1,1e6);return($Md^$_SESSION["token"]).":$Md";}function
verify_token(){list($Je,$Md)=explode(":",$_POST["token"]);return($Md^$_SESSION["token"])==$Je;}function
lzw_decompress($ya){$lb=256;$za=8;$Ia=array();$Sd=0;$Td=0;for($r=0;$r<strlen($ya);$r++){$Sd=($Sd<<8)+ord($ya[$r]);$Td+=8;if($Td>=$za){$Td-=$za;$Ia[]=$Sd>>$Td;$Sd&=(1<<$Td)-1;$lb++;if($lb>>$za)$za++;}}$kb=range("\0","\xFF");$L="";foreach($Ia
as$r=>$Ha){$ub=$kb[$Ha];if(!isset($ub))$ub=$if.$if[0];$L.=$ub;if($r)$kb[]=$if.$ub[0];$if=$ub;}return$L;}function
on_help($Na,$ie=0){return
script("mixin(qsl('select, input'), {onmouseover: function (event) { helpMouseover.call(this, event, $Na, $ie) }, onmouseout: helpMouseout});","");}function
edit_form($S,$l,$M,$T){global$b,$w,$Je,$j;$ve=$b->tableName(table_status1($S,true));page_header(($T?'Redigera':'Infoga'),$j,array("select"=>array($S,$ve)),$ve);$b->editRowPrint($S,$l,$M,$T);if($M===false)echo"<p class='error'>".'Inga rader.'."\n";echo'<form action="" method="post" enctype="multipart/form-data" id="form">
';if(!$l)echo"<p class='error'>".'Du har inga privilegier för att uppdatera den här tabellen.'."\n";else{echo"<table cellspacing='0' class='layout'>".script("qsl('table').onkeydown = editingKeydown;");foreach($l
as$E=>$k){echo"<tr><th>".$b->fieldName($k);$fb=$_GET["set"][bracket_escape($E)]??null;if($fb===null){$fb=$k["default"];if($k["type"]=="bit"&&preg_match("~^b'([01]*)'\$~",$fb,$Pd))$fb=$Pd[1];}$X=($M!==null?($M[$E]!=""&&$w=="sql"&&preg_match("~enum|set~",$k["type"])?(is_array($M[$E])?array_sum($M[$E]):+$M[$E]):(is_bool($M[$E])?+$M[$E]:$M[$E])):(!$T&&$k["auto_increment"]?"":(isset($_GET["select"])?false:$fb)));if(!$_POST["save"]&&is_string($X))$X=$b->editVal($X,$k);$Rb=null;if(isset($_POST["function"][$E]))$Rb=(string)$_POST["function"][$E];$p=($_POST["save"]?$Rb:($T&&preg_match('~^CURRENT_TIMESTAMP~i',$k["on_update"])?"now":($X===false?null:($X!==null?'':'NULL'))));if(!$_POST&&!$T&&$X==$k["default"]&&preg_match('~^[\w.]+\(~',$X))$p="SQL";if(preg_match("~time~",$k["type"])&&preg_match('~^CURRENT_TIMESTAMP~i',$X)){$X="";$p="now";}input($k,$X,$p);echo"\n";}if(!support("table"))echo"<tr>"."<th><input name='field_keys[]'>".script("qsl('input').oninput = fieldChange;")."<td class='function'>".html_select("field_funs[]",$b->editFunctions(array("null"=>isset($_GET["select"]))))."<td><input name='field_vals[]'>"."\n";echo"</table>\n";}echo"<p>\n";if($l){echo"<input type='submit' value='".'Spara'."'>\n";if(!isset($_GET["select"])){echo"<input type='submit' name='insert' value='".($T?'Spara och fortsätt att redigera':'Spara och infoga nästa')."' title='Ctrl+Shift+Enter'>\n",($T?script("qsl('input').onclick = function () { return !ajaxForm(this.form, '".'Sparar'."…', this); };"):"");}}echo($T?"<input type='submit' name='delete' value='".'Ta bort'."'>".confirm()."\n":($_POST||!$l?"":script("focus(qsa('td', qs('#form'))[1].firstChild);")));if(isset($_GET["select"]))hidden_fields(array("check"=>(array)$_POST["check"],"clone"=>$_POST["clone"],"all"=>$_POST["all"]));echo'<input type="hidden" name="referer" value="',h(isset($_POST["referer"])?$_POST["referer"]:$_SERVER["HTTP_REFERER"]),'">
<input type="hidden" name="save" value="1">
<input type="hidden" name="token" value="',$Je,'">
</form>
';}if(isset($_GET["file"])){if($_SERVER["HTTP_IF_MODIFIED_SINCE"]){header("HTTP/1.1 304 Not Modified");exit;}header("Expires: ".gmdate("D, d M Y H:i:s",time()+365*24*60*60)." GMT");header("Last-Modified: ".gmdate("D, d M Y H:i:s")." GMT");header("Cache-Control: immutable");if($_GET["file"]=="favicon.ico"){header("Content-Type: image/x-icon");echo
lzw_decompress("\0\0\0` \0X\0Z\0\0C> \r9\09\$M'JeRd]/LfS9m7I[m|:(nNiTe6+y<^e(,EY\$L\$uDK}>o[`*qJs5ͅmrY<+w|9˷M2}_땢\\\"V\n+MtBK*3ypl5I`V)OWs{OIAs۹㉥N&cO}~hH@GzJyGCcNJЪ`귊FC{вU@i>YJEiNR(9A%!CQ^yat:&۝YGH/\ngxs~@%y8ZUEOac@:\n;G>9i}@p,6&c Fő^%aRAQhIZԵ9z\\š`V5ZjoT9!^O)12l.I~^Qt꒦usI;OlB\$Q9q	\\eTsęUq2H֥J'(EvT!ѐ%EQFPv\\o'JtGIID\"e3-	oj&8E@uTICTUPy3ڶ>L^jbK#qD8ʒ\\Mdql\\y^]94hNk_g^GQ1)PQ8eMUsոbRha&]O5VUз-d23\\U@kWg+˷'gZٖE)KJ|qP=ҟO`[%wOgNMPcS	C!pdS#!KL=}ߠtp4!/k6uNdU28XDXHDvOb4IN<+q*?7WM!X,dXN(Ж=0Kvǘ25F #\$a&LSd\r(ЗFHИᖒ߱2:'M>RXcq)xdCp\rah'\0hDȠ`l&&B8Bm.rAeIQ2@). n`|ًF<䤳ZJ[a(KoP\"4D?TRgLJU_#8%u\$ASʆKJA8f17M]J&1=afK<w\$	MITTH&30?6ls\$DU\$ThI[5*MdbDPLsF\0'AJp-\rG3_k]|m%`_,8sE<2r!;|*TTQ-tق`<GlJi9GLKaK{\n=M+1h/:W\\[q\\Kaleݲu)v-~5UL?ED[1\\V66gĽfΪ8Io]h[ݒ R)!Ι˕W[5K'?};ii]3lFccL|^5;*ǸQ博&<Yu/rٗ\n-x8'\r1)#n9Vx%YdI\ntI*ȳs~m7.ǌRjX+^PeRײ:Je9{#';죥u2Rj]MFZVj]ZZk]mƲ");}elseif($_GET["file"]=="default.css"){header("Content-Type: text/css; charset=utf-8");echo
lzw_decompress("\nCo6C(\"#Ha1#yd1٘n:#(b.\rDc)a7Elñi1Ύs54f4ngsIhMдi:`,]YtL0hD*B0\rF&3xs'[Ʉtv4S%0XLW5)Yf\r^=~9g0\\@rQNn^yNj{opC%ʋGSZh5Z|>:'b{J)Ɠєt1*uS=^2*8t(0R,8j:x@9\n@1\nJ#4BRJFƋ>#J`HaahbC0\r4Ar&\nB54\$>+QA2DoMEL\"48=s5DLW7JGf**HjEK16ڸ,oLtJA\\\$Q|9-H@0\nxtV(o.+ܮ;1D8e*c\rT䍣B2܍z\n83=Ktƻu(kmׅ.G;+:2)cn<s5:6\nԡ)_\\6YL\"VV`c\$L;k&\$?XAWU48	Bޡڮz*[O24<?{36%;VV:\\A䎈	xnpxF<[xoW.U[Ãsd7rF&	bÒ]t*7ji=dZֹYy4:ie&Pg\\1C0:;;ٹ5Cnà\\܎#ܳ4{^g7u6NJ6OC#{!?fxw!70JJL48dpLàypC[.AltPQ'zl=N7@m\n/cTc]tהxiaD+pPpxׅUJ%Da`@^OEc)Ň@@A')hUb!AƸڠT~P\\*9Gi};`ˠh\r1Zlx9HI)AjRWI9!#̆[ysZb--q؇h7➀LjQʻ\"#lU`ׄ^Ar\rffV.QsnhGgN@e%?\$ᰂI;T\0`]B\r8[r2`\rҢ\rCKeF2ٺ\r'[t(),M)ڸ Se=*N@+9%Pin:܋T}ԎMC\rNtg%VÕ]V6Hʒl?Մ_Vhee,3ھF n%^kaM)_a-NB-v)rJ1NUly\0#YM˵Y`EM֭\"UH-_ #ܹE\"\rv42FL8wZ0]5Sw.!0ʴQ͏3E|%}AC0tLk3Pj/kbN`QQ7x_僧B<A8@%>\nx[&\rfy !SLsVG(¹	B\$a[F\\A8G&r;or>biRZMm,d\"<;\"Q?1uV~G,\0գ0c`IϣEPR^fBhUuɔ3CH(& i:\rt.W&5}UmߗpQNi`\ndi#(1QKҒ\nI,Yf`'(p7`q\rt\0U\rsr:ħ0و;A,v0p\rBPcrR^m.o\n=\\9%F7ZV#0|Yygf?/\"aMܿHnЬDdjl\0nAxsP(3}d#u`'p@[[T*`Z?\\!>˄vl}zf3; !(6/&A\08\0\0r\rp4{TT/!\ruAtH8JU`r9`j\r-H\"ՃATH ? }qA3l~a~2I^`Z\0004 ̓eP&\0p`n8pd%f\0sO`hD0\0p, i\$\\\0mO[ nD&`aP\\p2.0/0P0\nbVDd&&jd\"ioB0\$&\0aGJ& @&O7@i\$%\n0/bdo.\rro<\rP^Q\n	o`/\r^P}O6@nD d@0	^s\0#\0\$zIQjoc0M0OC [0@Q@`pf/P,ANp|PNF:ol@pPo@I`c	\$p/%\0HњpuP!h+\"A\$\"a_'/?U6DّCq fdiP\n%uQ\0e@pp#q\0\$o\npDB\0ϓ\00^P\"oB0ZO1	a*%Vj҄?/-!B,W\"ϑP\nPEFk/p_\rc+/\$S/7+/4_Lq'`D2%ύų#\r nב7p1#p7`O0\$o-!2Pѽ'&02	Nv/1\$io5\nO ip<23QD1</1-W\rCҍSٓ\n	\0\r؄JdrP#(J^nA N4\$(?\"CtH\r*\"1eptox\r|9ӰA \rADtKB@\0OCorsG`/kԍE,@O(KF,R+0A!/P\0%#s}PP;\rETE6\r@*hUK01uI8@^:`pR\0' T@b\"UaUdhi1SR+K	OtmJGTGE\0qq\n/jQ\0RA3s.Na\\@\n*1/\"a[/ϛ0Nك<aR0QUa/-P\\Hoap-%/\nskUѼ	\\#]6M!Tfr^\r*%PIZoKQ\"VE952S\$i+6OHѶZO'Zp2U M0<,Y1[Ui96-PR8p\r3?7O'cҳ`r;ӝ``%31A4%WhYqoG7oa,[Q7o sk_gii,rOij1CqI\0/!ғ]^TPHwM!wmQ01+mR},O?+T5pNK^Sfhssvk71f/5cg\0n@1zҴ\0koPI#\0i'E{GZ\rVxR`0#!/\nqc!1g?2nOj@pД@j\r<9Oq~@e0!3P#?YqلҸ5/?\0/6tIus cDi7nW\$UmA3kR?u\0r}Wt_bctō23p01r;bVv6;%17/)(]1W'QU1 v0\0gtADAWBtWX\"aXu9I<5CCTEEKATE4!W6) RccR\$kcL3:#T4'sOcV/\03\"T4j)PP%r;oLՏJT\$rnt6Ne95+#a2\r'MPo9UUmQX{Y ۛqu\0g&ZO-[IZ::?SA\0ڂ` D\"Bm*ePSj`JX\"ɍKFY>0nz\r:\00043,b,f(hޚLG3ICG.X.,7.j{\$]mrmV.Ξ\0N*vuXH`zON/V^ dɨD\0ƘhI\"˨piERVc9.O-.k\0DϻaE[HL\"b[Cj;EF9Q\"E|[2{M\0D	Fi\0h	\0`[痠E\ns\r0nsidCI@eŶ#eRivŜKn\\-|;7`qH`E܇BɚCӮܢ9||z^'p	c8-	bҕIP!G*@%:@C[	+; \0i(,LC!1[HPV[W`{dK)X\\ik=d.Е{Cכ񛿶<ɿ-I;Խ7\"Q?#ٛ9jE-%ۃ<<-\\)ͣY`\rIN!lHpI8!d]ܽٔ<yẉf	/j‘	gɵ<-DǛ>葱\rN]{юqd2]1tHFi[CcL\$_]Ӯ{kt]Ky՛i{\$Si =of{Ֆ[ݜݠ!]A=4e=#F;׾ĉ¿ܜ+ȓvƜMnsNHqw\\V?E<>	!'=|Rwd6ϊ\rwI?_yɾ!)fw˞3匥w~F#ɅxWt1(ɇRerW!I[ʤp)K1@HfI:Q S	r;5nbkqTʒ;  o*@r&Glq<\0.w6VckBhH(jOC7yC(mpV\n*1#n<[BR92E@&F(\n?J͐[ARWaػv8Wf#P:k{d`a't#tBmCXdr+sP,Adhwb?``b[ʡ\\+HXD90Ö]CY\$/Xk`/\"5|Q`Q\rj\\'CB?Uҏ,F4><agoA,(MNrHkeI,T*}òp8oPi yp\\'?9I&JNه:͏<.c01 3hB*aEzkhLmSԝ8:Ym˩vꗯ{	^^UQI{H[!\"ە^N{x4;!|}|nŵvb9ݎ<9qaY`c8;o\0f1\$o@5`} 7@h +((wq4i6x=ѣq;'9Qd# ſNiyq%>/ãb7ډ\rClFTqTaxˀ/Nt_^e\"6<1SƼ<G_+AWch=xL}GC8{Po,>9[]٘h@PÇ=4H~B\$N&4ѰPD, \0V@rj\$>:D\$	_Z#r;z4'|A HAPI}Dq*J8p\n EQ8\n  \$m`)W0ZI&ji2J²[Q\n~b@xkXrQAzb\$+ 	\"搐D\niC>\nҊ4)T{dQh`{&oBr,B(JjFād!\\jZQAO+2T,@");}elseif($_GET["file"]=="functions.js"){header("Content-Type: text/javascript; charset=utf-8");echo
lzw_decompress("f:gCI\n83)781x:\nOg#)r7\n\"`|2gSiH)NS\r\"0@)`(\$s6O!V/=' T4=iS6IOG#XVCsZ1.hp8,[H~Cz2lc3sIb4\nF8TIU*fzr0EyfY.:I(c΋!_l^^(N{S)rqYl٦33\n+GyixV3wuh^ra۔c\r(.Ch<\r)ѣ`743'm5\nP:2Pq C}ī38B0hRr(0b\\0Hr44B!p\$rZZ2܉.Ƀ(\\5|\nC(\"P.NRTΓ>HN8HP\\7Jp~2%OC1.C8·H*jS(/6KU<2pOI`ⳈdOH5-4pX25-Ңۈz7\"(P\\32:]U߅!]<Aۤiڰl\r\0v#J8wmɤ<ɠ%m;p#`XDiZN09占`v0C98a^M4Ł\r|7zF[\n(7vIĈ2,9Ì#ȨDWR;P'm3샂\n\0u39Cw2fp{и/	o4ax/ \\.=NJG@YE9a߉mg[ӹ=z{4\01CH:>X>~]\0dws!:%9~a\nj0XuS6dIV3̼r`AD@x9'A@\\Ta3((\nP`o{e9=	`\"	[B{!:x?)'|f8C ?Pu|@xR;U\0(.5joN)/97LA#8eACA0&#wKդRGZaH	UݑpRb`WްJ\n!MDxkVnO(#yN#h\"@1\0Ɖ#8L2\\rQ\0r\r`Yvb+1Hl`%z. M 5lNb\$2TxH`XHSWmb)'>'zP!и@?V=8\n+da07;ɹ*~WwܕR*T8CҮ]Xn'I2n\$p4JtX<>yK)qi%Ű4>V\nH{Jj1}6JSPCa2\"}s(ڙ^m*D9ͩɸu:AyT˩L͜:+p^VJGff5%y	ܞY[댝[\$EUYZuJdA6[-CHl)ʃm=GfclRVxU UXR\$ij˻G	2[T'\n5sFYhi\0X%_!\rE44ltm93lS{S*g8\$\"kHO)Jbʵp%\\Ps#)B:ai Z^\nkv2FPJʘnB,ܧfX5pB`ooI!=8)caH㨬b(JGaʏ\"BF T{Rp*e~2^ >v>%^13wCX=!gTe=9p>5;u+hMWZA\rė\\M\\3gМ[YvqX[b)2\rWL+ŊezA|ed9Ae\\ap.@_긳~cp%-ZW[QI7E5uȔ[6%PCio[1A4KD\$i.	?V{/_y]@^q&#\0O</q\"檭\\WUHyWtjV{nVf+μt,Ċ^g:LUiݻe*ǏW/-%嬍\"8C^&(E\\6ZN9ysv^/B0RZO\0;`N &Q;P2Β+=MtZ472hLWoK'& zHܧj?\nRDG*Ӊ-#<I,P,Z;h\0#NM>I`(E4\rT]\"V\0XQj~ bR`MN-RSN,\"0	d~y\r\r@`Q-\\s\n.P)]\0p\r]T*}\rp#-jEmp!ɨf@@W<cmXv	z|KJm\0@WX\0Kl<!N*GECZoBzТ\rxGeHNH(gj񂰯\0xoK@11lD\$Р`Dv V bSгH`2pn.qQJ+*fMp\r /D*\"w\$o2[QF`M|1Rho'&5#%j>jMگt@&rpGdDbtsR\$r!N2qo{*,DɯbrM`.QqD%јG	!J-+EDE`{0䧩0DE#p(7#2ܳbd73M&ysH\"74rL9-f*܋/rRŘRBn*ij@nB茴\\FIX%x f\$9J}9a0qsnFH|@E3};)k7|HKK5SdvR@  ( \r&*Ja@fp+Jk,w _?\"X\rN3'5&t%;A8Lrn?EQ\0%NSka8\0Ю<DUGF8VTDWe7`HtHn GJl;HTjN`@HDs[tΎ((Hexm7vyIҾ#T=>()\$_ԧOOQ-e(*GKdKt`DV!C8sDi<)3BKU;8SZB(.GDc,EuTpdl7J38DK\nbtNSHUt#{VluVZuF\r@`]6Zǌǀ][\\\rf(0SS43D'W:Sc:ǅb)fĢ#w5vs,rw6&\\m0\0ڜ\nJv66Kd)cu&R37NSX5>DUZ:Z'rT7Sk_G[Ĩ\$KU\\x<m5#[E\\ɞ0WJ*.\ro]#C*5kg|<-uSO7TS^hosp f֍8I\\#8_R{pe'2=S@[:e8ҕd35]r֪ֈ&De\$nW[3^vTԖw)vܭX0cmasZ xm׌בPyyz:^2b᎗9Uqo of>\";K|3yVhl	0No.%@OGvJ7M(A,\"[\0/, %Īσ*2x}˦gA!,,ǖ:&\r,3_-ԇlHo8vwSj)V)(NSXHXMXCx'/AXZ^|f҃i,ʸg؎[ڭ@QbLxJ\0jS Z	VB\"Ћc<ТtP5uP\rܬm\"yBCMnw^1 Njx./*ntI\"2\"=r\$:kwba.1>3h(Kom5;2g|B\"iD\rgBX%rV\0n\\FMm\0~\\͞4`.*\0@'9  d	{6瞠\nP놾In˛Y[VXm^oԢ?g<P@N/KsDeP\0xǤg}[sG俥S5u%%E@/OZe{LY))BR`	\nQCLyh783\0˲\06!N\"\$[h@aZZd\"\\\"Vg9[)hN`mL-՟fЍd oXh\"kӸsJ\"m2N2T.uǜyp'c)(ݦ[ɶ[`g;SZJzK&jZOp	ɧ@˪ZJz(Ӯ@{8\0_Ł\n3/|u0K:IV:YņEmRfn4fow1rN2sb0ق<d/eGfZXɌ<I<,b\rǖK\rJ\"H+q-wP,\$߫%U,՘@ӮLiT0K2yiĳ=|\\9wā2B5\n\refJ]ѳWGyb'HQ\\\n@ s#p8P}}j\ro`\rE RMMHJW nt\r*NoCMCB\"_HkRN#]d<.\\Xe&_G_n%9ƛm4\\Veg1'ao\r5p|[\0М@h tPbgӦ|)l{)~|̙קsz1vtFF)XA4y/g!ghNqh_j̏k+`0woSkW~,~P<3h~~DXE	\"ɺkRb\$BI!IYxF%FTg6-X/\"RmdkXQ`FS?V7Uвp&إsx@o|?MW`iHBC9꥚e;3;HP\"L5	#^S,5`#\"NɢB,\$o&n;xZ-]>q1 he:\0\r[\"*bw&6Vr\n>󹑭@SȚ܋>,43Y\r*=|Rڍ09il!SL\$`dN d%252(VBA ]E x*	dF38	{f(^>H&Mf^Mҙ\0]B\r	U*nPt`'?\n|,`:{x=8nHrFƧZpsO\n|	QN,O\\)+\n .)\nhY0,_\\n/\$CۄX\nP(\n`X,͹MpҬ++@ƌ8V5yN@'#dH\0X=	kV 	BAPѝ\r(Ydh~qb	6AR\0Xg|\r`\\8H. NJq2\rԉ2[P CJ	V'K[H@KMtT 	V=!%' \nV@!S~ugDWmɗZR-kbr iƬ=08AdLYRS!\"rxYC\0CF^{xȐŸ\r\"K=;A\0t L\"וEѧX#\nƵ/|<CWt^4v6R\"ted)^f6l.&`G5%RJMIB#9T-D\"FXڍ1~ߪJ.-jb`{hX'QHtzV2G!|K*#Gխ~cH1\n%`d3bYxnIȕ`ǷyILhB\0=l!AzS\rMHb\$E6F~Iȵ^aKOj*a*ϓt0-2\r|2@~NF6Ě('`\"CPE\$ep7R^@&/\$Rz\r\\vL?m\"6-\n`q\$@I!҄C움'	9jKv(6\$?[5ʒ#DC%)7Ŧ܂r5N*A̎2쩘<Bc-IR8^!QV]CFBS/zc&@yI\$35Ոl.HlK1 s\"5\rҶ\$)kQjJ܀E.7v^\" Rn%=\nto8^68@ħɦQ MxK8`0%T3 iqɠ:E\\d2I>p\r8Yi]UEd`ԧ^#2dEb\0cL/Y!OTĸ˦ eh\n`jypxB`ð+@4T؀igo\0^PSRumҏ(gߙܥ;5y̴9,Q4J9q'XݼP#	q8?%4&q.Yͤ:q)v5!!ȅk8ʀ {\$IKخQґٖж't0~KYcH) |+&Z\"@\nB DE{#eHL\"V\"y1 j)9ب6iY>s-hЃϱ\0^md9iz#'EA@)aX Q0:F0⷟CUn[bʳ+iHL9cv-!PF+d(K\"bdƄ@_C %|;Pxu,Y<	QpbєW|b\"c!ZsU?[Jٶ]-'x_90vŗF\nʤXB	q]֗FQJBkb(=XG֐v\"	CT̵H6R4ih!^Q\0{j(BCxki:<8HRp\"!Ҝ#[ԍd`0++;*MѶ]%Y,XEP,Rb8a`=wIڡZQ1 !Fb\"Tt\n*bnYhْ,FZpVE¾T|NC@zբ5q9*^\rʎtqhZc=]!HwNK'ԈNTEUS%8(UEdC\rN\rC&iz9");}elseif($_GET["file"]=="jush.js"){header("Content-Type: text/javascript; charset=utf-8");echo
lzw_decompress('');}else{header("Content-Type: image/gif");switch($_GET["file"]){case"plus.gif":echo'';break;case"cross.gif":echo'';break;case"up.gif":echo'';break;case"down.gif":echo'';break;case"arrow.gif":echo'';break;}}exit;}if($_GET["script"]=="version"){$o=file_open_lock(get_temp_dir()."/adminer.version");if($o)file_write_unlock($o,serialize(array("version"=>$_POST["version"])));exit;}global$b,$f,$i,$ob,$sb,$_b,$j,$ac,$dc,$aa,$vc,$w,$ba,$Fc,$hd,$_d,$oe,$hc,$Je,$Ne,$Pe,$We,$ca;if(!$_SERVER["REQUEST_URI"])$_SERVER["REQUEST_URI"]=$_SERVER["ORIG_PATH_INFO"];if(!strpos($_SERVER["REQUEST_URI"],'?')&&$_SERVER["QUERY_STRING"]!="")$_SERVER["REQUEST_URI"].="?$_SERVER[QUERY_STRING]";if($_SERVER["HTTP_X_FORWARDED_PREFIX"])$_SERVER["REQUEST_URI"]=$_SERVER["HTTP_X_FORWARDED_PREFIX"].$_SERVER["REQUEST_URI"];$aa=($_SERVER["HTTPS"]&&strcasecmp($_SERVER["HTTPS"],"off"))||ini_bool("session.cookie_secure");@ini_set("session.use_trans_sid",false);if(!defined("SID")){session_cache_limiter("");session_name("adminer_sid");$vd=array(0,preg_replace('~\?.*~','',$_SERVER["REQUEST_URI"]),"",$aa);if(version_compare(PHP_VERSION,'5.2.0')>=0)$vd[]=true;call_user_func_array('session_set_cookie_params',$vd);session_start();}remove_slashes(array(&$_GET,&$_POST,&$_COOKIE),$Ob);if(function_exists("get_magic_quotes_runtime")&&get_magic_quotes_runtime())set_magic_quotes_runtime(false);@set_time_limit(0);@ini_set("zend.ze1_compatibility_mode",false);@ini_set("precision",15);function
get_lang(){return'sv';}function
lang($Me,$ed=null){if(is_array($Me)){$Bd=($ed==1?0:1);$Me=$Me[$Bd];}$Me=str_replace("%d","%s",$Me);$ed=format_number($ed);return
sprintf($Me,$ed);}if(extension_loaded('pdo')){class
Min_PDO{var$_result,$server_info,$affected_rows,$errno,$error,$pdo;function
__construct(){global$b;$Bd=array_search("SQL",$b->operators);if($Bd!==false)unset($b->operators[$Bd]);}function
dsn($qb,$U,$I,$F=array()){$F[PDO::ATTR_ERRMODE]=PDO::ERRMODE_SILENT;$F[PDO::ATTR_STATEMENT_CLASS]=array('Min_PDOStatement');try{$this->pdo=new
PDO($qb,$U,$I,$F);}catch(Exception$Eb){auth_error(h($Eb->getMessage()));}$this->server_info=@$this->pdo->getAttribute(PDO::ATTR_SERVER_VERSION);}function
quote($R){return$this->pdo->quote($R);}function
query($J,$Qe=false){$K=$this->pdo->query($J);$this->error="";if(!$K){list(,$this->errno,$this->error)=$this->pdo->errorInfo();if(!$this->error)$this->error='Okänt fel.';return
false;}$this->store_result($K);return$K;}function
multi_query($J){return$this->_result=$this->query($J);}function
store_result($K=null){if(!$K){$K=$this->_result;if(!$K)return
false;}if($K->columnCount()){$K->num_rows=$K->rowCount();return$K;}$this->affected_rows=$K->rowCount();return
true;}function
next_result(){if(!$this->_result)return
false;$this->_result->_offset=0;return@$this->_result->nextRowset();}function
result($J,$k=0){$K=$this->query($J);if(!$K)return
false;$M=$K->fetch();return$M[$k];}}class
Min_PDOStatement
extends
PDOStatement{var$_offset=0,$num_rows;function
fetch_assoc(){return$this->fetch(PDO::FETCH_ASSOC);}function
fetch_row(){return$this->fetch(PDO::FETCH_NUM);}function
fetch_field(){$M=(object)$this->getColumnMeta($this->_offset++);$M->orgtable=$M->table;$M->orgname=$M->name;$M->charsetnr=(in_array("blob",(array)$M->flags)?63:0);return$M;}}}$ob=array();function
add_driver($s,$E){global$ob;$ob[$s]=$E;}function
get_driver($s){global$ob;return$ob[$s];}class
Min_SQL{var$_conn;function
__construct($f){$this->_conn=$f;}function
select($S,$O,$Z,$q,$G=array(),$y=1,$H=0,$Fd=false){global$b,$w;$v=(count($q)<count($O));$J=$b->selectQueryBuild($O,$Z,$q,$G,$y,$H);if(!$J)$J="SELECT".limit(($_GET["page"]!="last"&&$y!=""&&$q&&$v&&$w=="sql"?"SQL_CALC_FOUND_ROWS ":"").implode(", ",$O)."\nFROM ".table($S),($Z?"\nWHERE ".implode(" AND ",$Z):"").($q&&$v?"\nGROUP BY ".implode(", ",$q):"").($G?"\nORDER BY ".implode(", ",$G):""),($y!=""?+$y:null),($H?$y*$H:0),"\n");$me=microtime(true);$L=$this->_conn->query($J);if($Fd)echo$b->selectQuery($J,$me,!$L);return$L;}function
delete($S,$Kd,$y=0){$J="FROM ".table($S);return
queries("DELETE".($y?limit1($S,$J,$Kd):" $J$Kd"));}function
update($S,$Q,$Kd,$y=0,$de="\n"){$bf=array();foreach($Q
as$x=>$W)$bf[]="$x = $W";$J=table($S)." SET$de".implode(",$de",$bf);return
queries("UPDATE".($y?limit1($S,$J,$Kd,$de):" $J$Kd"));}function
insert($S,$Q){return
queries("INSERT INTO ".table($S).($Q?" (".implode(", ",array_keys($Q)).")\nVALUES (".implode(", ",$Q).")":" DEFAULT VALUES"));}function
insertUpdate($S,$N,$Ed){return
false;}function
begin(){return
queries("BEGIN");}function
commit(){return
queries("COMMIT");}function
rollback(){return
queries("ROLLBACK");}function
slowQuery($J,$De){}function
convertSearch($pc,$W,$k){return$pc;}function
value($W,$k){return(method_exists($this->_conn,'value')?$this->_conn->value($W,$k):(is_resource($W)?stream_get_contents($W):$W));}function
quoteBinary($Vd){return
q($Vd);}function
warnings(){return'';}function
tableHelp($E){}}$ob["mssql"]="MS SQL (beta)";define("DRIVER","mssql");if(extension_loaded("sqlsrv")){class
Min_DB{var$extension="sqlsrv",$_link,$_result,$server_info,$affected_rows,$errno,$error;function
_get_error(){$this->error="";foreach(sqlsrv_errors()as$j){$this->errno=$j["code"];$this->error.="$j[message]\n";}$this->error=rtrim($this->error);}function
connect($P,$U,$I){global$b;$h=$b->database();$Ta=array("UID"=>$U,"PWD"=>$I,"CharacterSet"=>"UTF-8");if($h!="")$Ta["Database"]=$h;$this->_link=@sqlsrv_connect(preg_replace('~:~',',',$P),$Ta);if($this->_link){$tc=sqlsrv_server_info($this->_link);$this->server_info=$tc['SQLServerVersion'];}else$this->_get_error();return(bool)$this->_link;}function
quote($R){return"'".str_replace("'","''",$R)."'";}function
select_db($cb){return$this->query("USE ".idf_escape($cb));}function
query($J,$Qe=false){$K=sqlsrv_query($this->_link,$J);$this->error="";if(!$K){$this->_get_error();return
false;}return$this->store_result($K);}function
multi_query($J){$this->_result=sqlsrv_query($this->_link,$J);$this->error="";if(!$this->_result){$this->_get_error();return
false;}return
true;}function
store_result($K=null){if(!$K)$K=$this->_result;if(!$K)return
false;if(sqlsrv_field_metadata($K))return
new
Min_Result($K);$this->affected_rows=sqlsrv_rows_affected($K);return
true;}function
next_result(){return$this->_result?sqlsrv_next_result($this->_result):null;}function
result($J,$k=0){$K=$this->query($J);if(!is_object($K))return
false;$M=$K->fetch_row();return$M[$k];}}class
Min_Result{var$_result,$_offset=0,$_fields,$num_rows;function
__construct($K){$this->_result=$K;}function
_convert($M){foreach((array)$M
as$x=>$W){if(is_a($W,'DateTime'))$M[$x]=$W->format("Y-m-d H:i:s");}return$M;}function
fetch_assoc(){return$this->_convert(sqlsrv_fetch_array($this->_result,SQLSRV_FETCH_ASSOC));}function
fetch_row(){return$this->_convert(sqlsrv_fetch_array($this->_result,SQLSRV_FETCH_NUMERIC));}function
fetch_field(){if(!$this->_fields)$this->_fields=sqlsrv_field_metadata($this->_result);$k=$this->_fields[$this->_offset++];$L=new
stdClass;$L->name=$k["Name"];$L->orgname=$k["Name"];$L->type=($k["Type"]==1?254:0);return$L;}function
seek($fd){for($r=0;$r<$fd;$r++)sqlsrv_fetch($this->_result);}function
__destruct(){sqlsrv_free_stmt($this->_result);}}}elseif(extension_loaded("mssql")){class
Min_DB{var$extension="MSSQL",$_link,$_result,$server_info,$affected_rows,$error;function
connect($P,$U,$I){$this->_link=@mssql_connect($P,$U,$I);if($this->_link){$K=$this->query("SELECT SERVERPROPERTY('ProductLevel'), SERVERPROPERTY('Edition')");if($K){$M=$K->fetch_row();$this->server_info=$this->result("sp_server_info 2",2)." [$M[0]] $M[1]";}}else$this->error=mssql_get_last_message();return(bool)$this->_link;}function
quote($R){return"'".str_replace("'","''",$R)."'";}function
select_db($cb){return
mssql_select_db($cb);}function
query($J,$Qe=false){$K=@mssql_query($J,$this->_link);$this->error="";if(!$K){$this->error=mssql_get_last_message();return
false;}if($K===true){$this->affected_rows=mssql_rows_affected($this->_link);return
true;}return
new
Min_Result($K);}function
multi_query($J){return$this->_result=$this->query($J);}function
store_result(){return$this->_result;}function
next_result(){return
mssql_next_result($this->_result->_result);}function
result($J,$k=0){$K=$this->query($J);if(!is_object($K))return
false;return
mssql_result($K->_result,0,$k);}}class
Min_Result{var$_result,$_offset=0,$_fields,$num_rows;function
__construct($K){$this->_result=$K;$this->num_rows=mssql_num_rows($K);}function
fetch_assoc(){return
mssql_fetch_assoc($this->_result);}function
fetch_row(){return
mssql_fetch_row($this->_result);}function
num_rows(){return
mssql_num_rows($this->_result);}function
fetch_field(){$L=mssql_fetch_field($this->_result);$L->orgtable=$L->table;$L->orgname=$L->name;return$L;}function
seek($fd){mssql_data_seek($this->_result,$fd);}function
__destruct(){mssql_free_result($this->_result);}}}elseif(extension_loaded("pdo_dblib")){class
Min_DB
extends
Min_PDO{var$extension="PDO_DBLIB";function
connect($P,$U,$I){$this->dsn("dblib:charset=utf8;host=".str_replace(":",";unix_socket=",preg_replace('~:(\d)~',';port=\1',$P)),$U,$I);return
true;}function
select_db($cb){return$this->query("USE ".idf_escape($cb));}}}class
Min_Driver
extends
Min_SQL{function
insertUpdate($S,$N,$Ed){foreach($N
as$Q){$T=array();$Z=array();foreach($Q
as$x=>$W){$T[]="$x = $W";if(isset($Ed[idf_unescape($x)]))$Z[]="$x = $W";}if(!queries("MERGE ".table($S)." USING (VALUES(".implode(", ",$Q).")) AS source (c".implode(", c",range(1,count($Q))).") ON ".implode(" AND ",$Z)." WHEN MATCHED THEN UPDATE SET ".implode(", ",$T)." WHEN NOT MATCHED THEN INSERT (".implode(", ",array_keys($Q)).") VALUES (".implode(", ",$Q).");"))return
false;}return
true;}function
begin(){return
queries("BEGIN TRANSACTION");}}function
idf_escape($pc){return"[".str_replace("]","]]",$pc)."]";}function
table($pc){return($_GET["ns"]!=""?idf_escape($_GET["ns"]).".":"").idf_escape($pc);}function
connect(){global$b;$f=new
Min_DB;$Xa=$b->credentials();if($f->connect($Xa[0],$Xa[1],$Xa[2]))return$f;return$f->error;}function
get_databases(){return
get_vals("SELECT name FROM sys.databases WHERE name NOT IN ('master', 'tempdb', 'model', 'msdb')");}function
limit($J,$Z,$y,$fd=0,$de=" "){return($y!==null?" TOP (".($y+$fd).")":"")." $J$Z";}function
limit1($S,$J,$Z,$de="\n"){return
limit($J,$Z,1,0,$de);}function
db_collation($h,$La){global$f;return$f->result("SELECT collation_name FROM sys.databases WHERE name = ".q($h));}function
engines(){return
array();}function
logged_user(){global$f;return$f->result("SELECT SUSER_NAME()");}function
tables_list(){return
get_key_vals("SELECT name, type_desc FROM sys.all_objects WHERE schema_id = SCHEMA_ID(".q(get_schema()).") AND type IN ('S', 'U', 'V') ORDER BY name");}function
count_tables($db){global$f;$L=array();foreach($db
as$h){$f->select_db($h);$L[$h]=$f->result("SELECT COUNT(*) FROM INFORMATION_SCHEMA.TABLES");}return$L;}function
table_status($E=""){$L=array();foreach(get_rows("SELECT ao.name AS Name, ao.type_desc AS Engine, (SELECT value FROM fn_listextendedproperty(default, 'SCHEMA', schema_name(schema_id), 'TABLE', ao.name, null, null)) AS Comment FROM sys.all_objects AS ao WHERE schema_id = SCHEMA_ID(".q(get_schema()).") AND type IN ('S', 'U', 'V') ".($E!=""?"AND name = ".q($E):"ORDER BY name"))as$M){if($E!="")return$M;$L[$M["Name"]]=$M;}return$L;}function
is_view($we){return$we["Engine"]=="VIEW";}function
fk_support($we){return
true;}function
fields($S){$Pa=get_key_vals("SELECT objname, cast(value as varchar(max)) FROM fn_listextendedproperty('MS_DESCRIPTION', 'schema', ".q(get_schema()).", 'table', ".q($S).", 'column', NULL)");$L=array();foreach(get_rows("SELECT c.max_length, c.precision, c.scale, c.name, c.is_nullable, c.is_identity, c.collation_name, t.name type, CAST(d.definition as text) [default]
FROM sys.all_columns c
JOIN sys.all_objects o ON c.object_id = o.object_id
JOIN sys.types t ON c.user_type_id = t.user_type_id
LEFT JOIN sys.default_constraints d ON c.default_object_id = d.parent_column_id
WHERE o.schema_id = SCHEMA_ID(".q(get_schema()).") AND o.type IN ('S', 'U', 'V') AND o.name = ".q($S))as$M){$Oe=$M["type"];$Jc=(preg_match("~char|binary~",$Oe)?$M["max_length"]:($Oe=="decimal"?"$M[precision],$M[scale]":""));$L[$M["name"]]=array("field"=>$M["name"],"full_type"=>$Oe.($Jc?"($Jc)":""),"type"=>$Oe,"length"=>$Jc,"default"=>$M["default"],"null"=>$M["is_nullable"],"auto_increment"=>$M["is_identity"],"collation"=>$M["collation_name"],"privileges"=>array("insert"=>1,"select"=>1,"update"=>1),"primary"=>$M["is_identity"],"comment"=>$Pa[$M["name"]],);}return$L;}function
indexes($S,$g=null){$L=array();foreach(get_rows("SELECT i.name, key_ordinal, is_unique, is_primary_key, c.name AS column_name, is_descending_key
FROM sys.indexes i
INNER JOIN sys.index_columns ic ON i.object_id = ic.object_id AND i.index_id = ic.index_id
INNER JOIN sys.columns c ON ic.object_id = c.object_id AND ic.column_id = c.column_id
WHERE OBJECT_NAME(i.object_id) = ".q($S),$g)as$M){$E=$M["name"];$L[$E]["type"]=($M["is_primary_key"]?"PRIMARY":($M["is_unique"]?"UNIQUE":"INDEX"));$L[$E]["lengths"]=array();$L[$E]["columns"][$M["key_ordinal"]]=$M["column_name"];$L[$E]["descs"][$M["key_ordinal"]]=($M["is_descending_key"]?'1':null);}return$L;}function
view($E){global$f;return
array("select"=>preg_replace('~^(?:[^[]|\[[^]]*])*\s+AS\s+~isU','',$f->result("SELECT VIEW_DEFINITION FROM INFORMATION_SCHEMA.VIEWS WHERE TABLE_SCHEMA = SCHEMA_NAME() AND TABLE_NAME = ".q($E))));}function
collations(){$L=array();foreach(get_vals("SELECT name FROM fn_helpcollations()")as$Ka)$L[preg_replace('~_.*~','',$Ka)][]=$Ka;return$L;}function
information_schema($h){return
false;}function
error(){global$f;return
nl_br(h(preg_replace('~^(\[[^]]*])+~m','',$f->error)));}function
create_database($h,$Ka){return
queries("CREATE DATABASE ".idf_escape($h).(preg_match('~^[a-z0-9_]+$~i',$Ka)?" COLLATE $Ka":""));}function
drop_databases($db){return
queries("DROP DATABASE ".implode(", ",array_map('idf_escape',$db)));}function
rename_database($E,$Ka){if(preg_match('~^[a-z0-9_]+$~i',$Ka))queries("ALTER DATABASE ".idf_escape(DB)." COLLATE $Ka");queries("ALTER DATABASE ".idf_escape(DB)." MODIFY NAME = ".idf_escape($E));return
true;}function
auto_increment(){return" IDENTITY".($_POST["Auto_increment"]!=""?"(".number($_POST["Auto_increment"]).",1)":"")." PRIMARY KEY";}function
alter_table($S,$E,$l,$Tb,$Oa,$zb,$Ka,$sa,$wd){$ma=array();$Pa=array();foreach($l
as$k){$d=idf_escape($k[0]);$W=$k[1];if(!$W)$ma["DROP"][]=" COLUMN $d";else{$W[1]=preg_replace("~( COLLATE )'(\\w+)'~",'\1\2',$W[1]);$Pa[$k[0]]=$W[5];unset($W[5]);if($k[0]=="")$ma["ADD"][]="\n  ".implode("",$W).($S==""?substr($Tb[$W[0]],16+strlen($W[0])):"");else{unset($W[6]);if($d!=$W[0])queries("EXEC sp_rename ".q(table($S).".$d").", ".q(idf_unescape($W[0])).", 'COLUMN'");$ma["ALTER COLUMN ".implode("",$W)][]="";}}}if($S=="")return
queries("CREATE TABLE ".table($E)." (".implode(",",(array)$ma["ADD"])."\n)");if($S!=$E)queries("EXEC sp_rename ".q(table($S)).", ".q($E));if($Tb)$ma[""]=$Tb;foreach($ma
as$x=>$W){if(!queries("ALTER TABLE ".idf_escape($E)." $x".implode(",",$W)))return
false;}foreach($Pa
as$x=>$W){$Oa=substr($W,9);queries("EXEC sp_dropextendedproperty @name = N'MS_Description', @level0type = N'Schema', @level0name = ".q(get_schema()).", @level1type = N'Table', @level1name = ".q($E).", @level2type = N'Column', @level2name = ".q($x));queries("EXEC sp_addextendedproperty @name = N'MS_Description', @value = ".$Oa.", @level0type = N'Schema', @level0name = ".q(get_schema()).", @level1type = N'Table', @level1name = ".q($E).", @level2type = N'Column', @level2name = ".q($x));}return
true;}function
alter_indexes($S,$ma){$t=array();$pb=array();foreach($ma
as$W){if($W[2]=="DROP"){if($W[0]=="PRIMARY")$pb[]=idf_escape($W[1]);else$t[]=idf_escape($W[1])." ON ".table($S);}elseif(!queries(($W[0]!="PRIMARY"?"CREATE $W[0] ".($W[0]!="INDEX"?"INDEX ":"").idf_escape($W[1]!=""?$W[1]:uniqid($S."_"))." ON ".table($S):"ALTER TABLE ".table($S)." ADD PRIMARY KEY")." (".implode(", ",$W[2]).")"))return
false;}return(!$t||queries("DROP INDEX ".implode(", ",$t)))&&(!$pb||queries("ALTER TABLE ".table($S)." DROP ".implode(", ",$pb)));}function
last_id(){global$f;return$f->result("SELECT SCOPE_IDENTITY()");}function
explain($f,$J){$f->query("SET SHOWPLAN_ALL ON");$L=$f->query($J);$f->query("SET SHOWPLAN_ALL OFF");return$L;}function
found_rows($we,$Z){}function
foreign_keys($S){$L=array();foreach(get_rows("EXEC sp_fkeys @fktable_name = ".q($S))as$M){$n=&$L[$M["FK_NAME"]];$n["db"]=$M["PKTABLE_QUALIFIER"];$n["table"]=$M["PKTABLE_NAME"];$n["source"][]=$M["FKCOLUMN_NAME"];$n["target"][]=$M["PKCOLUMN_NAME"];}return$L;}function
truncate_tables($xe){return
apply_queries("TRUNCATE TABLE",$xe);}function
drop_views($df){return
queries("DROP VIEW ".implode(", ",array_map('table',$df)));}function
drop_tables($xe){return
queries("DROP TABLE ".implode(", ",array_map('table',$xe)));}function
move_tables($xe,$df,$ze){return
apply_queries("ALTER SCHEMA ".idf_escape($ze)." TRANSFER",array_merge($xe,$df));}function
trigger($E){if($E=="")return
array();$N=get_rows("SELECT s.name [Trigger],
CASE WHEN OBJECTPROPERTY(s.id, 'ExecIsInsertTrigger') = 1 THEN 'INSERT' WHEN OBJECTPROPERTY(s.id, 'ExecIsUpdateTrigger') = 1 THEN 'UPDATE' WHEN OBJECTPROPERTY(s.id, 'ExecIsDeleteTrigger') = 1 THEN 'DELETE' END [Event],
CASE WHEN OBJECTPROPERTY(s.id, 'ExecIsInsteadOfTrigger') = 1 THEN 'INSTEAD OF' ELSE 'AFTER' END [Timing],
c.text
FROM sysobjects s
JOIN syscomments c ON s.id = c.id
WHERE s.xtype = 'TR' AND s.name = ".q($E));$L=reset($N);if($L)$L["Statement"]=preg_replace('~^.+\s+AS\s+~isU','',$L["text"]);return$L;}function
triggers($S){$L=array();foreach(get_rows("SELECT sys1.name,
CASE WHEN OBJECTPROPERTY(sys1.id, 'ExecIsInsertTrigger') = 1 THEN 'INSERT' WHEN OBJECTPROPERTY(sys1.id, 'ExecIsUpdateTrigger') = 1 THEN 'UPDATE' WHEN OBJECTPROPERTY(sys1.id, 'ExecIsDeleteTrigger') = 1 THEN 'DELETE' END [Event],
CASE WHEN OBJECTPROPERTY(sys1.id, 'ExecIsInsteadOfTrigger') = 1 THEN 'INSTEAD OF' ELSE 'AFTER' END [Timing]
FROM sysobjects sys1
JOIN sysobjects sys2 ON sys1.parent_obj = sys2.id
WHERE sys1.xtype = 'TR' AND sys2.name = ".q($S))as$M)$L[$M["name"]]=array($M["Timing"],$M["Event"]);return$L;}function
trigger_options(){return
array("Timing"=>array("AFTER","INSTEAD OF"),"Event"=>array("INSERT","UPDATE","DELETE"),"Type"=>array("AS"),);}function
schemas(){return
get_vals("SELECT name FROM sys.schemas");}function
get_schema(){global$f;if($_GET["ns"]!="")return$_GET["ns"];return$f->result("SELECT SCHEMA_NAME()");}function
set_schema($Wd){return
true;}function
use_sql($cb){return"USE ".idf_escape($cb);}function
show_variables(){return
array();}function
show_status(){return
array();}function
convert_field($k){}function
unconvert_field($k,$L){return$L;}function
support($Lb){return
preg_match('~^(comment|columns|database|drop_col|indexes|descidx|scheme|sql|table|trigger|view|view_trigger)$~',$Lb);}function
driver_config(){$Pe=array();$oe=array();foreach(array('Nummer'=>array("tinyint"=>3,"smallint"=>5,"int"=>10,"bigint"=>20,"bit"=>1,"decimal"=>0,"real"=>12,"float"=>53,"smallmoney"=>10,"money"=>20),'Datum och tid'=>array("date"=>10,"smalldatetime"=>19,"datetime"=>19,"datetime2"=>19,"time"=>8,"datetimeoffset"=>10),'Strängar'=>array("char"=>8000,"varchar"=>8000,"text"=>2147483647,"nchar"=>4000,"nvarchar"=>4000,"ntext"=>1073741823),'Binärt'=>array("binary"=>8000,"varbinary"=>8000,"image"=>2147483647),)as$x=>$W){$Pe+=$W;$oe[$x]=array_keys($W);}return
array('possible_drivers'=>array("SQLSRV","MSSQL","PDO_DBLIB"),'jush'=>"mssql",'types'=>$Pe,'structured_types'=>$oe,'unsigned'=>array(),'operators'=>array("=","<",">","<=",">=","!=","LIKE","LIKE %%","IN","IS NULL","NOT LIKE","NOT IN","IS NOT NULL"),'functions'=>array("distinct","len","lower","round","upper"),'grouping'=>array("avg","count","count distinct","max","min","sum"),'edit_functions'=>array(array("date|time"=>"getdate",),array("int|decimal|real|float|money|datetime"=>"+/-","char|text"=>"+",)),);}class
Adminer{var$operators=array("<=",">=");var$_values=array();function
name(){return"<a href='https://www.adminerevo.org'".target_blank()." id='h1'>".'Redigerare'."</a>";}function
credentials(){return
array(SERVER,$_GET["username"],get_password());}function
connectSsl(){}function
permanentLogin($Wa=false){return
password_file($Wa);}function
bruteForceKey(){return$_SERVER["REMOTE_ADDR"];}function
serverName($P){}function
database(){global$f;if($f){$db=$this->databases(false);return(!$db?$f->result("SELECT SUBSTRING_INDEX(CURRENT_USER, '@', 1)"):$db[(information_schema($db[0])?1:0)]);}}function
schemas(){return
schemas();}function
databases($Qb=true){return
get_databases($Qb);}function
queryTimeout(){return
5;}function
headers(){}function
csp(){return
csp();}function
head(){return
true;}function
css(){$L=array();$m="adminer.css";if(file_exists($m))$L[]=$m;return$L;}function
loginForm(){echo"<table cellspacing='0' class='layout'>\n",$this->loginFormField('username','<tr><th>'.'Användarnamn'.'<td>','<input type="hidden" name="auth[driver]" value="server"><input name="auth[username]" id="username" value="'.h($_GET["username"]).'" autocomplete="username" autocapitalize="off">'.script("focus(qs('#username'));")),$this->loginFormField('password','<tr><th>'.'Lösenord'.'<td>','<input type="password" name="auth[password]" autocomplete="current-password">'."\n"),"</table>\n","<p><input type='submit' value='".'Logga in'."'>\n",checkbox("auth[permanent]",1,$_COOKIE["adminer_permanent"],'Permanent inloggning')."\n";}function
loginFormField($E,$kc,$X){return$kc.$X;}function
login($Oc,$I){return
true;}function
tableName($ue){return
h($ue["Comment"]!=""?$ue["Comment"]:$ue["Name"]);}function
fieldName($k,$G=0){return
h(preg_replace('~\s+\[.*\]$~','',($k["comment"]!=""?$k["comment"]:$k["field"])));}function
selectLinks($ue,$Q=""){$a=$ue["Name"];if($Q!==null)echo'<p class="tabs"><a href="'.h(ME.'edit='.urlencode($a).$Q).'">'.'Ny sak'."</a>\n";}function
foreignKeys($S){return
foreign_keys($S);}function
backwardKeys($S,$te){$L=array();foreach(get_rows("SELECT TABLE_NAME, CONSTRAINT_NAME, COLUMN_NAME, REFERENCED_COLUMN_NAME
FROM information_schema.KEY_COLUMN_USAGE
WHERE TABLE_SCHEMA = ".q($this->database())."
AND REFERENCED_TABLE_SCHEMA = ".q($this->database())."
AND REFERENCED_TABLE_NAME = ".q($S)."
ORDER BY ORDINAL_POSITION",null,"")as$M)$L[$M["TABLE_NAME"]]["keys"][$M["CONSTRAINT_NAME"]][$M["COLUMN_NAME"]]=$M["REFERENCED_COLUMN_NAME"];foreach($L
as$x=>$W){$E=$this->tableName(table_status($x,true));if($E!=""){$Xd=preg_quote($te);$de="(:|\\s*-)?\\s+";$L[$x]["name"]=(preg_match("(^$Xd$de(.+)|^(.+?)$de$Xd\$)iu",$E,$A)?$A[2].$A[3]:$E);}else
unset($L[$x]);}return$L;}function
backwardKeysPrint($va,$M){foreach($va
as$S=>$ua){foreach($ua["keys"]as$Ma){$z=ME.'select='.urlencode($S);$r=0;foreach($Ma
as$d=>$W)$z.=where_link($r++,$d,$M[$W]);echo"<a href='".h($z)."'>".h($ua["name"])."</a>";$z=ME.'edit='.urlencode($S);foreach($Ma
as$d=>$W)$z.="&set".urlencode("[".bracket_escape($d)."]")."=".urlencode($M[$W]);echo"<a href='".h($z)."' title='".'Ny sak'."'>+</a> ";}}}function
selectQuery($J,$me,$Jb=false){return"<!--\n".str_replace("--","--><!-- ",$J)."\n(".format_time($me).")\n-->\n";}function
rowDescription($S){foreach(fields($S)as$k){if(preg_match("~varchar|character varying~",$k["type"]))return
idf_escape($k["field"]);}return"";}function
rowDescriptions($N,$Vb){$L=$N;foreach($N[0]as$x=>$W){if(list($S,$s,$E)=$this->_foreignColumn($Vb,$x)){$qc=array();foreach($N
as$M)$qc[$M[$x]]=q($M[$x]);$jb=$this->_values[$S];if(!$jb)$jb=get_key_vals("SELECT $s, $E FROM ".table($S)." WHERE $s IN (".implode(", ",$qc).")");foreach($N
as$D=>$M){if(isset($M[$x]))$L[$D][$x]=(string)$jb[$M[$x]];}}}return$L;}function
selectLink($W,$k){}function
selectVal($W,$z,$k,$qd){$L=$W;$z=h($z);if(preg_match('~blob|bytea~',$k["type"])&&!is_utf8($W)){$L=lang(array('%d byte','%d bytes'),strlen($qd));if(preg_match("~^(GIF|\xFF\xD8\xFF|\x89PNG\x0D\x0A\x1A\x0A)~",$qd))$L="<img src='$z' alt='$L'>";}if(like_bool($k)&&$L!="")$L=(preg_match('~^(1|t|true|y|yes|on)$~i',$W)?'ja':'nej');if($z)$L="<a href='$z'".(is_url($z)?target_blank():"").">$L</a>";if(!$z&&!like_bool($k)&&preg_match(number_type(),$k["type"]))$L="<div class='number'>$L</div>";elseif(preg_match('~date~',$k["type"]))$L="<div class='datetime'>$L</div>";return$L;}function
editVal($W,$k){if(preg_match('~date|timestamp~',$k["type"])&&$W!==null)return
preg_replace('~^(\d{2}(\d+))-(0?(\d+))-(0?(\d+))~','$1-$3-$5',$W);return$W;}function
selectColumnsPrint($O,$e){}function
selectSearchPrint($Z,$e,$u){$Z=(array)$_GET["where"];echo'<fieldset id="fieldset-search"><legend>'.'Sök'."</legend><div>\n";$Bc=array();foreach($Z
as$x=>$W)$Bc[$W["col"]]=$x;$r=0;$l=fields($_GET["select"]);foreach($e
as$E=>$ib){$k=$l[$E];if(preg_match("~enum~",$k["type"])||like_bool($k)){$x=$Bc[$E];$r--;echo"<div>".h($ib)."<input type='hidden' name='where[$r][col]' value='".h($E)."'>:",(like_bool($k)?" <select name='where[$r][val]'>".optionlist(array(""=>"",'nej','ja'),$Z[$x]["val"],true)."</select>":enum_input("checkbox"," name='where[$r][val][]'",$k,(array)$Z[$x]["val"],($k["null"]?0:null))),"</div>\n";unset($e[$E]);}elseif(is_array($F=$this->_foreignKeyOptions($_GET["select"],$E))){if($l[$E]["null"])$F[0]='('.'tom'.')';$x=$Bc[$E];$r--;echo"<div>".h($ib)."<input type='hidden' name='where[$r][col]' value='".h($E)."'><input type='hidden' name='where[$r][op]' value='='>: <select name='where[$r][val]'>".optionlist($F,$Z[$x]["val"],true)."</select></div>\n";unset($e[$E]);}}$r=0;foreach($Z
as$W){if(($W["col"]==""||$e[$W["col"]])&&"$W[col]$W[val]"!=""){echo"<div><select name='where[$r][col]'><option value=''>(".'överallt'.")".optionlist($e,$W["col"],true)."</select>",html_select("where[$r][op]",array(-1=>"")+$this->operators,$W["op"]),"<input type='search' name='where[$r][val]' value='".h($W["val"])."'>".script("mixin(qsl('input'), {onkeydown: selectSearchKeydown, onsearch: selectSearchSearch});",""),"<input type='image' src='".h(preg_replace("~\\?.*~","",ME)."?file=cross.gif&version=4.8.4")."' class='jsonly icon' title='",h('Ta bort'),"' alt='x'>".script('qsl(".icon").onclick = selectRemoveRow;',""),"</div>\n";$r++;}}echo"<div><select name='where[$r][col]'><option value=''>(".'överallt'.")".optionlist($e,null,true)."</select>",script("qsl('select').onchange = selectAddRow;",""),html_select("where[$r][op]",array(-1=>"")+$this->operators),"<input type='search' name='where[$r][val]'>",script("mixin(qsl('input'), {onchange: function () { this.parentNode.firstChild.onchange(); }, onsearch: selectSearchSearch});"),"<input type='image' src='".h(preg_replace("~\\?.*~","",ME)."?file=cross.gif&version=4.8.4")."' class='jsonly icon' title='",h('Ta bort'),"' alt='x'>",script('qsl(".icon").onclick = selectRemoveRow;',""),"</div>","</div></fieldset>\n";}function
selectOrderPrint($G,$e,$u){$pd=array();foreach($u
as$x=>$t){$G=array();foreach($t["columns"]as$W)$G[]=$e[$W];if(count(array_filter($G,'strlen'))>1&&$x!="PRIMARY")$pd[$x]=implode(", ",$G);}if($pd){echo'<fieldset><legend>'.'Sortera'."</legend><div>","<select name='index_order'>".optionlist(array(""=>"")+$pd,($_GET["order"][0]!=""?"":$_GET["index_order"]),true)."</select>","</div></fieldset>\n";}if($_GET["order"])echo"<div style='display: none;'>".hidden_fields(array("order"=>array(1=>reset($_GET["order"])),"desc"=>($_GET["desc"]?array(1=>1):array()),))."</div>\n";}function
selectLimitPrint($y){echo"<fieldset><legend>".'Begränsning'."</legend><div>";echo
html_select("limit",array("","50","100"),$y),"</div></fieldset>\n";}function
selectLengthPrint($Ae){}function
selectActionPrint($u){echo"<fieldset><legend>".'Åtgärd'."</legend><div>","<input type='submit' value='".'Välj'."'>","</div></fieldset>\n";}function
selectCommandPrint(){return
true;}function
selectImportPrint(){return
true;}function
selectEmailPrint($wb,$e){if($wb){print_fieldset("email",'Email',$_POST["email_append"]);echo"<div>",script("qsl('div').onkeydown = partialArg(bodyKeydown, 'email');"),"<p>".'Från'.": <input name='email_from' value='".h($_POST?$_POST["email_from"]:$_COOKIE["adminer_email"])."'>\n",'Ämne'.": <input name='email_subject' value='".h($_POST["email_subject"])."'>\n","<p><textarea name='email_message' rows='15' cols='75'>".h($_POST["email_message"].($_POST["email_append"]?'{$'."$_POST[email_addition]}":""))."</textarea>\n","<p>".script("qsl('p').onkeydown = partialArg(bodyKeydown, 'email_append');","").html_select("email_addition",$e,$_POST["email_addition"])."<input type='submit' name='email_append' value='".'Infoga'."'>\n";echo"<p>".'Bilagor'.": <input type='file' name='email_files[]'>".script("qsl('input').onchange = emailFileChange;"),"<p>".(count($wb)==1?'<input type="hidden" name="email_field" value="'.h(key($wb)).'">':html_select("email_field",$wb)),"<input type='submit' name='email' value='".'Skicka'."'>".confirm(),"</div>\n","</div></fieldset>\n";}}function
selectColumnsProcess($e,$u){return
array(array(),array());}function
selectSearchProcess($l,$u){global$i;$L=array();foreach((array)$_GET["where"]as$x=>$Z){$Ja=$Z["col"];$kd=$Z["op"];$W=$Z["val"];if(($x<0?"":$Ja).$W!=""){$Qa=array();foreach(($Ja!=""?array($Ja=>$l[$Ja]):$l)as$E=>$k){if($Ja!=""||is_numeric($W)||!preg_match(number_type(),$k["type"])){$E=idf_escape($E);if($Ja!=""&&$k["type"]=="enum")$Qa[]=(in_array(0,$W)?"$E IS NULL OR ":"")."$E IN (".implode(", ",array_map('intval',$W)).")";else{$Be=preg_match('~char|text|enum|set~',$k["type"]);$X=$this->processInput($k,(!$kd&&$Be&&preg_match('~^[^%]+$~',$W)?"%$W%":$W));$Qa[]=$i->convertSearch($E,$W,$k).($X=="NULL"?" IS".($kd==">="?" NOT":"")." $X":(in_array($kd,$this->operators)||$kd=="="?" $kd $X":($Be?" LIKE $X":" IN (".str_replace(",","', '",$X).")")));if($x<0&&$W=="0")$Qa[]="$E IS NULL";}}}$L[]=($Qa?"(".implode(" OR ",$Qa).")":"1 = 0");}}return$L;}function
selectOrderProcess($l,$u){$sc=$_GET["index_order"];if($sc!="")unset($_GET["order"][1]);if($_GET["order"])return
array(idf_escape(reset($_GET["order"])).($_GET["desc"]?" DESC":""));foreach(($sc!=""?array($u[$sc]):$u)as$t){if($sc!=""||$t["type"]=="INDEX"){$fc=array_filter($t["descs"]);$ib=false;foreach($t["columns"]as$W){if(preg_match('~date|timestamp~',$l[$W]["type"])){$ib=true;break;}}$L=array();foreach($t["columns"]as$x=>$W)$L[]=idf_escape($W).(($fc?$t["descs"][$x]:$ib)?" DESC":"");return$L;}}return
array();}function
selectLimitProcess(){return(isset($_GET["limit"])?$_GET["limit"]:"50");}function
selectLengthProcess(){return"100";}function
selectEmailProcess($Z,$Vb){if($_POST["email_append"])return
true;if($_POST["email"]){$be=0;if($_POST["all"]||$_POST["check"]){$k=idf_escape($_POST["email_field"]);$qe=$_POST["email_subject"];$C=$_POST["email_message"];preg_match_all('~\{\$([a-z0-9_]+)\}~i',"$qe.$C",$B);$N=get_rows("SELECT DISTINCT $k".($B[1]?", ".implode(", ",array_map('idf_escape',array_unique($B[1]))):"")." FROM ".table($_GET["select"])." WHERE $k IS NOT NULL AND $k != ''".($Z?" AND ".implode(" AND ",$Z):"").($_POST["all"]?"":" AND ((".implode(") OR (",array_map('where_check',(array)$_POST["check"]))."))"));$l=fields($_GET["select"]);foreach($this->rowDescriptions($N,$Vb)as$M){$Qd=array('{\\'=>'{');foreach($B[1]as$W)$Qd['{$'."$W}"]=$this->editVal($M[$W],$l[$W]);$vb=$M[$_POST["email_field"]];if(is_mail($vb)&&send_mail($vb,strtr($qe,$Qd),strtr($C,$Qd),$_POST["email_from"],$_FILES["email_files"]))$be++;}}cookie("adminer_email",$_POST["email_from"]);redirect(remove_from_uri(),lang(array('%d email har blivit skickat.','%d email har blivit skickade.'),$be));}return
false;}function
selectQueryBuild($O,$Z,$q,$G,$y,$H){return"";}function
messageQuery($J,$Ce,$Jb=false){return" <span class='time'>".@date("H:i:s")."</span><!--\n".str_replace("--","--><!-- ",$J)."\n".($Ce?"($Ce)\n":"")."-->";}function
editRowPrint($S,$l,$M,$T){}function
editFunctions($k){$L=array();if($k["null"]&&preg_match('~blob~',$k["type"]))$L["NULL"]='tom';$L[""]=($k["null"]||$k["auto_increment"]||like_bool($k)?"":"*");if(preg_match('~date|time~',$k["type"]))$L["now"]='nu';if(preg_match('~_(md5|sha1)$~i',$k["field"],$A))$L[]=strtolower($A[1]);return$L;}function
editInput($S,$k,$c,$X){if($k["type"]=="enum"){$F=array();$Zd=$X;if(isset($_GET["select"])){$F[-1]='original';if($Zd===null)$Zd=-1;}if($k["null"]){$F[""]="NULL";if($X===null&&!isset($_GET["select"]))$Zd="";}$F[0]='tom';preg_match_all("~'((?:[^']|'')*)'~",$k["length"],$B);foreach($B[1]as$r=>$W){$W=stripcslashes(str_replace("''","'",$W));$F[$r+1]=$W;if($X===$W)$Zd=$r+1;}return"<select$c>".optionlist($F,(string)$Zd,1)."</select>";}$F=$this->_foreignKeyOptions($S,$k["field"],$X);if($F!==null)return(is_array($F)?"<select$c>".optionlist($F,$X,true)."</select>":"<input value='".h($X)."'$c class='hidden'>"."<input value='".h($F)."' class='jsonly'>"."<div></div>".script("qsl('input').oninput = partial(whisper, '".ME."script=complete&source=".urlencode($S)."&field=".urlencode($k["field"])."&value=');
qsl('div').onclick = whisperClick;",""));if(like_bool($k))return'<input type="checkbox" value="1"'.(preg_match('~^(1|t|true|y|yes|on)$~i',$X)?' checked':'')."$c>";$lc="";if(preg_match('~time~',$k["type"]))$lc='HH:MM:SS';if(preg_match('~date|timestamp~',$k["type"]))$lc='yyyy-mm-dd'.($lc?" [$lc]":"");if($lc)return"<input value='".h($X)."'$c> ($lc)";if(preg_match('~_(md5|sha1)$~i',$k["field"]))return"<input type='password' value='".h($X)."'$c>";return'';}function
editHint($S,$k,$X){return(preg_match('~\s+(\[.*\])$~',($k["comment"]!=""?$k["comment"]:$k["field"]),$A)?h(" $A[1]"):'');}function
processInput($k,$X,$p=""){if($p=="now")return"$p()";$L=$X;if(preg_match('~date|timestamp~',$k["type"])&&preg_match('(^'.str_replace('\$1','(?P<p1>\d*)',preg_replace('~(\\\\\\$([2-6]))~','(?P<p\2>\d{1,2})',preg_quote('$1-$3-$5'))).'(.*))',$X,$A))$L=($A["p1"]!=""?$A["p1"]:($A["p2"]!=""?($A["p2"]<70?20:19).$A["p2"]:gmdate("Y")))."-$A[p3]$A[p4]-$A[p5]$A[p6]".end($A);$L=($k["type"]=="bit"&&preg_match('~^[0-9]+$~',$X)?$L:q($L));if($X==""&&like_bool($k))$L="'0'";elseif($X==""&&($k["null"]||!preg_match('~char|text~',$k["type"])))$L="NULL";elseif(preg_match('~^(md5|sha1)$~',$p))$L="$p($L)";return
unconvert_field($k,$L);}function
dumpOutput(){return
array();}function
dumpFormat(){return
array('csv'=>'CSV,','csv;'=>'CSV;','tsv'=>'TSV');}function
dumpDatabase($h){}function
dumpTable($S,$pe,$_c=0){echo"\xef\xbb\xbf";}function
dumpData($S,$pe,$J){global$f;$K=$f->query($J,1);if($K){while($M=$K->fetch_assoc()){if($pe=="table"){dump_csv(array_keys($M));$pe="INSERT";}dump_csv($M);}}}function
dumpFilename($oc){return
friendly_url($oc);}function
dumpHeaders($oc,$Yc=false){$Hb="csv";header("Content-Type: text/csv; charset=utf-8");return$Hb;}function
importServerPath(){}function
homepage(){return
true;}function
navigation($Xc){global$ca;echo'<h1>
',$this->name(),' <span class="version">',$ca,'</span>
<a href="https://www.adminerevo.org"',target_blank(),' id="version">',(version_compare($ca,$_COOKIE["adminer_version"])<0?h($_COOKIE["adminer_version"]):""),'</a>
</h1>
';if($Xc=="auth"){$Pb=true;foreach((array)$_SESSION["pwds"]as$Y=>$fe){foreach($fe[""]as$U=>$I){if($I!==null){if($Pb){echo"<ul id='logins'>",script("mixin(qs('#logins'), {onmouseover: menuOver, onmouseout: menuOut});");$Pb=false;}echo"<li><a href='".h(auth_url($Y,"",$U))."'>".($U!=""?h($U):"<i>".'tom'."</i>")."</a>\n";}}}}else{$this->databasesPrint($Xc);if($Xc!="db"&&$Xc!="ns"){$we=table_status('',true);if(!$we)echo"<p class='message'>".'Inga tabeller.'."\n";else$this->tablesPrint($we);}}}function
databasesPrint($Xc){}function
tablesPrint($xe){echo"<ul id='tables'>",script("mixin(qs('#tables'), {onmouseover: menuOver, onmouseout: menuOut});");foreach($xe
as$M){echo'<li>';$E=$this->tableName($M);if(isset($M["Engine"])&&$E!=""){echo"<a href='".h(ME).'select='.urlencode($M["Name"])."'".bold($_GET["select"]==$M["Name"]||$_GET["edit"]==$M["Name"],"select")." title='".'Välj data'."'>$E</a>\n","<a href='".h(ME).'select='.urlencode($M["Name"])."'".bold($_GET["select"]==$M["Name"]||$_GET["edit"]==$M["Name"],"")." title='".'Välj data'."'>$E</a>\n";}}echo"</ul>\n";}function
_foreignColumn($Vb,$d){foreach((array)$Vb[$d]as$Ub){if(count($Ub["source"])==1){$E=$this->rowDescription($Ub["table"]);if($E!=""){$s=idf_escape($Ub["target"][0]);return
array($Ub["table"],$s,$E);}}}}function
_foreignKeyOptions($S,$d,$X=null){global$f;if(list($ze,$s,$E)=$this->_foreignColumn(column_foreign_keys($S),$d)){$L=&$this->_values[$ze];if($L===null){$we=table_status($ze);$L=($we["Rows"]>1000?"":array(""=>"")+get_key_vals("SELECT $s, $E FROM ".table($ze)." ORDER BY 2"));}if(!$L&&$X!==null)return$f->result("SELECT $E FROM ".table($ze)." WHERE $s = ".q($X));return$L;}}}$b=(function_exists('adminer_object')?adminer_object():new
Adminer);$Ra=driver_config();$Cd=$Ra['possible_drivers'];$w=$Ra['jush'];$Pe=$Ra['types'];$oe=$Ra['structured_types'];$We=$Ra['unsigned'];$nd=$Ra['operators'];$md=isset($Ra['operator_regexp'])&&in_array($Ra['operator_regexp'],$nd)?$Ra['operator_regexp']:null;$ac=$Ra['functions'];$dc=$Ra['grouping'];$sb=$Ra['edit_functions'];if($b->operators===null){$b->operators=$nd;$b->operator_regexp=$md;}define("SERVER",$_GET[DRIVER]);define("DB",$_GET["db"]);define("ME",preg_replace('~\?.*~','',relative_uri()).'?'.(sid()?SID.'&':'').(SERVER!==null?DRIVER."=".urlencode(SERVER).'&':'').(isset($_GET["username"])?"username=".urlencode($_GET["username"]).'&':'').(DB!=""?'db='.urlencode(DB).'&'.(isset($_GET["ns"])?"ns=".urlencode($_GET["ns"])."&":""):''));$ca="4.8.4";function
page_header($Ee,$j="",$Ba=array(),$Fe=""){global$ba,$ca,$b,$ob,$w;page_headers();if(is_ajax()&&$j){page_messages($j);exit;}$Ge=$Ee.($Fe!=""?": $Fe":"");$He=strip_tags($Ge.(SERVER!=""&&SERVER!="localhost"?h(" - ".SERVER):"")." - ".$b->name());echo'<!DOCTYPE html>
<html lang="sv" dir="ltr">
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta name="robots" content="noindex">
<title>',$He,'</title>
<link rel="stylesheet" type="text/css" href="',h(preg_replace("~\\?.*~","",ME)."?file=default.css&version=4.8.4"),'">
',script_src(preg_replace("~\\?.*~","",ME)."?file=functions.js&version=4.8.4");if($b->head()){echo'<link rel="shortcut icon" type="image/x-icon" href="',h(preg_replace("~\\?.*~","",ME)."?file=favicon.ico&version=4.8.4"),'">
<link rel="apple-touch-icon" href="',h(preg_replace("~\\?.*~","",ME)."?file=favicon.ico&version=4.8.4"),'">
';foreach($b->css()as$Za){echo'<link rel="stylesheet" type="text/css" href="',h($Za),'">
';}}echo'
<body class="ltr nojs editor">
';$m=get_temp_dir()."/adminer.version";if(!$_COOKIE["adminer_version"]&&file_exists($m)&&filemtime($m)+86400>time()){$cf=unserialize(file_get_contents($m));$_COOKIE["adminer_version"]=$cf["version"];}echo'<script',nonce(),'>
mixin(document.body, {onkeydown: bodyKeydown, onclick: bodyClick',(isset($_COOKIE["adminer_version"])?"":", onload: partial(verifyVersion, '$ca', '".js_escape(ME)."', '".get_token()."')");?>});
document.body.className = document.body.className.replace(/ nojs/, ' js');
var offlineMessage = '<?php echo
js_escape('Du är offline.'),'\';
var thousandsSeparator = \'',js_escape(','),'\';
</script>

<div id="help" class="jush-',$w,' jsonly hidden"></div>
',script("mixin(qs('#help'), {onmouseover: function () { helpOpen = 1; }, onmouseout: helpMouseout});"),'
<div id="content">
';if($Ba!==null){$z=substr(preg_replace('~\b(username|db|ns)=[^&]*&~','',ME),0,-1);echo'<p id="breadcrumb"><a href="'.h($z?$z:".").'">'.$ob[DRIVER].'</a> &raquo; ';$z=substr(preg_replace('~\b(db|ns)=[^&]*&~','',ME),0,-1);$P=$b->serverName(SERVER);$P=($P!=""?$P:'Server');if($Ba===false)echo"$P\n";else{echo"<a href='".h($z)."' accesskey='1' title='Alt+Shift+1'>$P</a> &raquo; ";if($_GET["ns"]!=""||(DB!=""&&is_array($Ba)))echo'<a href="'.h($z."&db=".urlencode(DB).(support("scheme")?"&ns=":"")).'">'.h(DB).'</a> &raquo; ';if(is_array($Ba)){if($_GET["ns"]!="")echo'<a href="'.h(substr(ME,0,-1)).'">'.h($_GET["ns"]).'</a> &raquo; ';foreach($Ba
as$x=>$W){$ib=(is_array($W)?$W[1]:h($W));if($ib!="")echo"<a href='".h(ME."$x=").urlencode(is_array($W)?$W[0]:$W)."'>$ib</a> &raquo; ";}}echo"$Ee\n";}}echo"<h2>$Ge</h2>\n","<div id='ajaxstatus' class='jsonly hidden'></div>\n";restart_session();page_messages($j);$db=&get_session("dbs");if(DB!=""&&$db&&!in_array(DB,$db,true))$db=null;stop_session();define("PAGE_HEADER",1);}function
page_headers(){global$b;header("Content-Type: text/html; charset=utf-8");header("Cache-Control: no-cache");header("X-Frame-Options: deny");header("X-XSS-Protection: 0");header("X-Content-Type-Options: nosniff");header("Referrer-Policy: origin-when-cross-origin");foreach($b->csp()as$Ya){$ic=array();foreach($Ya
as$x=>$W)$ic[]="$x $W";header("Content-Security-Policy: ".implode("; ",$ic));}$b->headers();}function
csp(){return
array(array("script-src"=>"'self' 'unsafe-inline' 'nonce-".get_nonce()."' 'strict-dynamic'","connect-src"=>"'self' https://api.github.com/repos/adminerevo/adminerevo/releases/latest","frame-src"=>"'self'","object-src"=>"'none'","base-uri"=>"'none'","form-action"=>"'self'",),);}function
get_nonce(){static$cd;if(!$cd)$cd=base64_encode(rand_string());return$cd;}function
page_messages($j){$Xe=preg_replace('~^[^?]*~','',$_SERVER["REQUEST_URI"]);$Wc=[];if(isset($_SESSION["messages"][$Xe]))$Wc=$_SESSION["messages"][$Xe];if(count($Wc)>0){echo"<div class='message'>".implode("</div>\n<div class='message'>",$Wc)."</div>".script("messagesPrint();");unset($_SESSION["messages"][$Xe]);}if($j)echo"<div class='error'>$j</div>\n";}function
page_footer($Xc=""){global$b,$Je;echo'</div>

';if($Xc!="auth"){echo'<form action="" method="post">
<p class="logout">
<input type="submit" name="logout" value="Logga ut" id="logout">
<input type="hidden" name="token" value="',$Je,'">
</p>
</form>
';}echo'<div id="menu">
';$b->navigation($Xc);echo'</div>
',script("setupSubmitHighlight(document);"),script("setupCopyToClipboard(document);"),"</body>\n</html>";}function
int32($D){while($D>=2147483648)$D-=4294967296;while($D<=-2147483649)$D+=4294967296;return(int)$D;}function
long2str($V,$ff){$Vd='';foreach($V
as$W)$Vd.=pack('V',$W);if($ff)return
substr($Vd,0,end($V));return$Vd;}function
str2long($Vd,$ff){$V=array_values(unpack('V*',str_pad($Vd,4*ceil(strlen($Vd)/4),"\0")));if($ff)$V[]=strlen($Vd);return$V;}function
xxtea_mx($kf,$jf,$se,$Ac){return
int32((($kf>>5&0x7FFFFFF)^$jf<<2)+(($jf>>3&0x1FFFFFFF)^$kf<<4))^int32(($se^$jf)+($Ac^$kf));}function
encrypt_string($ne,$x){if($ne=="")return"";$x=array_values(unpack("V*",pack("H*",md5($x))));$V=str2long($ne,true);$D=count($V)-1;$kf=$V[$D];$jf=$V[0];$Id=floor(6+52/($D+1));$se=0;while($Id-->0){$se=int32($se+0x9E3779B9);$rb=$se>>2&3;for($sd=0;$sd<$D;$sd++){$jf=$V[$sd+1];$Zc=xxtea_mx($kf,$jf,$se,$x[$sd&3^$rb]);$kf=int32($V[$sd]+$Zc);$V[$sd]=$kf;}$jf=$V[0];$Zc=xxtea_mx($kf,$jf,$se,$x[$sd&3^$rb]);$kf=int32($V[$D]+$Zc);$V[$D]=$kf;}return
long2str($V,false);}function
decrypt_string($ne,$x){if($ne=="")return"";if(!$x)return
false;$x=array_values(unpack("V*",pack("H*",md5($x))));$V=str2long($ne,false);$D=count($V)-1;$kf=$V[$D];$jf=$V[0];$Id=floor(6+52/($D+1));$se=int32($Id*0x9E3779B9);while($se){$rb=$se>>2&3;for($sd=$D;$sd>0;$sd--){$kf=$V[$sd-1];$Zc=xxtea_mx($kf,$jf,$se,$x[$sd&3^$rb]);$jf=int32($V[$sd]-$Zc);$V[$sd]=$jf;}$kf=$V[$D];$Zc=xxtea_mx($kf,$jf,$se,$x[$sd&3^$rb]);$jf=int32($V[0]-$Zc);$V[0]=$jf;$se=int32($se-0x9E3779B9);}return
long2str($V,true);}$f='';$hc=$_SESSION["token"];if(!$hc)$_SESSION["token"]=rand(1,1e6);$Je=get_token();$_d=array();if($_COOKIE["adminer_permanent"]){foreach(explode(" ",$_COOKIE["adminer_permanent"])as$W){list($x)=explode(":",$W);$_d[$x]=$W;}}function
validate_server_input(){if(SERVER=="")return;$xd=parse_url(SERVER);if(!$xd)auth_error('Invalid server or credentials.');if(isset($xd['user'])||isset($xd['pass'])||isset($xd['query'])||isset($xd['fragment']))auth_error('Invalid server or credentials.');if(isset($xd['scheme'])&&!preg_match('~^(https?)$~i',$xd['scheme']))auth_error('Invalid server or credentials.');$mc=(isset($xd['host'])?$xd['host']:'').(isset($xd['path'])?$xd['path']:'');if(strpos(rtrim($mc,'/'),'/')!==false)auth_error('Invalid server or credentials.');if(isset($xd['port'])&&($xd['port']<1024||$xd['port']>65535))auth_error('Anslutning till privilegierade portar är inte tillåtet.');}function
build_http_url($P,$U,$I,$hb,$gb=null){if(!preg_match('~^(https?://)?([^:]*)(:\d+)?$~',rtrim($P,'/'),$B)){$this->error='Invalid server or credentials.';return
false;}return($B[1]?:"http://").($U!==""||$I!==""?"$U:$I@":"").($B[2]!==""?$B[2]:$hb).(isset($B[3])?$B[3]:($gb?":$gb":""));}function
add_invalid_login(){global$b;$o=file_open_lock(get_temp_dir()."/adminer.invalid");if(!$o)return;$yc=unserialize(stream_get_contents($o));$Ce=time();if($yc){foreach($yc
as$zc=>$W){if($W[0]<$Ce)unset($yc[$zc]);}}$xc=&$yc[$b->bruteForceKey()];if(!$xc)$xc=array($Ce+30*60,0);$xc[1]++;file_write_unlock($o,serialize($yc));}function
check_invalid_login(){global$b;$yc=unserialize(@file_get_contents(get_temp_dir()."/adminer.invalid"));$xc=($yc?$yc[$b->bruteForceKey()]:array());if($xc===null)return;$bd=($xc[1]>29?$xc[0]-time():0);if($bd>0)auth_error(lang(array('För många misslyckade inloggningar, försök igen om %d minut.','För många misslyckade inloggningar, försök igen om %d minuter.'),ceil($bd/60)));}$ra=$_POST["auth"];if($ra){session_regenerate_id();$Y=$ra["driver"];$P=trim($ra["server"]);$U=$ra["username"];$I=(string)$ra["password"];$h=$ra["db"];set_password($Y,$P,$U,$I);$_SESSION["db"][$Y][$P][$U][$h]=true;if($ra["permanent"]){$x=base64_encode($Y)."-".base64_encode($P)."-".base64_encode($U)."-".base64_encode($h);$Gd=$b->permanentLogin(true);$_d[$x]="$x:".base64_encode($Gd?encrypt_string($I,$Gd):"");cookie("adminer_permanent",implode(" ",$_d));}if(count($_POST)==1||DRIVER!=$Y||SERVER!=$P||$_GET["username"]!==$U||DB!=$h)redirect(auth_url($Y,$P,$U,$h));}elseif($_POST["logout"]&&(!$hc||verify_token())){foreach(array("pwds","db","dbs","queries")as$x)set_session($x,null);unset_permanent();redirect(substr(preg_replace('~\b(username|db|ns)=[^&]*&~','',ME),0,-1),'Du är nu utloggad.');}elseif($_d&&!$_SESSION["pwds"]){session_regenerate_id();$Gd=$b->permanentLogin();foreach($_d
as$x=>$W){list(,$Fa)=explode(":",$W);list($Y,$P,$U,$h)=array_map('base64_decode',explode("-",$x));set_password($Y,$P,$U,decrypt_string(base64_decode($Fa),$Gd));$_SESSION["db"][$Y][$P][$U][$h]=true;}}function
unset_permanent(){global$_d;foreach($_d
as$x=>$W){list($Y,$P,$U,$h)=array_map('base64_decode',explode("-",$x));if($Y==DRIVER&&$P==SERVER&&$U==$_GET["username"]&&$h==DB)unset($_d[$x]);}cookie("adminer_permanent",implode(" ",$_d));}function
auth_error($j){global$b,$hc;$ge=session_name();if(isset($_GET["username"])){header("HTTP/1.1 403 Forbidden");if(($_COOKIE[$ge]||$_GET[$ge])&&!$hc)$j='Session har löpt ut, vänligen logga in igen.';else{restart_session();add_invalid_login();$I=get_password();if($I!==null){if($I===false)$j.=($j?'<br>':'').sprintf('Huvudlösenordet har löpt ut. <a href="https://www.adminer.org/en/extension/"%s>Implementera</a> %s en metod för att göra det permanent.',target_blank(),'<code>permanentLogin()</code>');set_password(DRIVER,SERVER,$_GET["username"],null);}unset_permanent();}}if(!$_COOKIE[$ge]&&$_GET[$ge]&&ini_bool("session.use_only_cookies"))$j='Support för sessioner måste vara på.';$vd=session_get_cookie_params();cookie("adminer_key",($_COOKIE["adminer_key"]?$_COOKIE["adminer_key"]:rand_string()),$vd["lifetime"]);page_header('Logga in',$j,null);echo"<form action='' method='post'>\n","<div>";if(hidden_fields($_POST,array("auth")))echo"<p class='message'>".'Åtgärden kommer att utföras efter en lyckad inloggning med samma inloggningsuppgifter.'."\n";echo"</div>\n";$b->loginForm();echo"</form>\n";page_footer("auth");exit;}if(isset($_GET["username"])&&!class_exists("Min_DB")){unset($_SESSION["pwds"][DRIVER]);unset_permanent();page_header('Inget tillägg',sprintf('Inga av de PHP-tilläggen som stöds (%s) är tillgängliga.',implode(", ",$Cd)),false);page_footer("auth");exit;}stop_session(true);if(isset($_GET["username"])&&is_string(get_password())){validate_server_input();check_invalid_login();$f=connect();$i=new
Min_Driver($f);}$Oc=null;if(!is_object($f)||($Oc=$b->login($_GET["username"],get_password()))!==true){$j=(is_string($f)?h($f):(is_string($Oc)?$Oc:'Invalid server or credentials.'));auth_error($j.(preg_match('~^ | $~',get_password())?'<br>'.'Det finns ett mellanslag i lösenordet, vilket kan vara anledningen.':''));}if($_POST["logout"]&&$hc&&!verify_token()){page_header('Logga ut','Ogiltig CSRF-token. Skicka formuläret igen.');page_footer("db");exit;}if($ra&&$_POST["token"])$_POST["token"]=$Je;$j='';if($_POST){if(!verify_token()){$uc="max_input_vars";$Uc=ini_get($uc);if(extension_loaded("suhosin")){foreach(array("suhosin.request.max_vars","suhosin.post.max_vars")as$x){$W=ini_get($x);if($W&&(!$Uc||$W<$Uc)){$uc=$x;$Uc=$W;}}}$j=(!$_POST["token"]&&$Uc?sprintf('Högsta nummer tillåtna fält är överskridet. Vänligen höj %s.',"'$uc'"):'Ogiltig CSRF-token. Skicka formuläret igen.'.' '.'Om du inte skickade en förfrågan från Adminer så kan du stänga den här sidan.');}}elseif($_SERVER["REQUEST_METHOD"]=="POST"){$j=sprintf('POST-datan är för stor. Minska det eller höj %s-direktivet.',"'post_max_size'");if(isset($_GET["sql"]))$j.=' '.'Du kan ladda upp en stor SQL-fil via FTP och importera det från servern.';}function
email_header($ic){return"=?UTF-8?B?".base64_encode($ic)."?=";}function
send_mail($vb,$qe,$C,$Zb="",$Nb=array()){$Ab=(DIRECTORY_SEPARATOR=="/"?"\n":"\r\n");$C=str_replace("\n",$Ab,wordwrap(str_replace("\r","","$C\n")));$Aa=uniqid("boundary");$qa="";foreach((array)$Nb["error"]as$x=>$W){if(!$W)$qa.="--$Aa$Ab"."Content-Type: ".str_replace("\n","",$Nb["type"][$x]).$Ab."Content-Disposition: attachment; filename=\"".preg_replace('~["\n]~','',$Nb["name"][$x])."\"$Ab"."Content-Transfer-Encoding: base64$Ab$Ab".chunk_split(base64_encode(file_get_contents($Nb["tmp_name"][$x])),76,$Ab).$Ab;}$xa="";$jc="Content-Type: text/plain; charset=utf-8$Ab"."Content-Transfer-Encoding: 8bit";if($qa){$qa.="--$Aa--$Ab";$xa="--$Aa$Ab$jc$Ab$Ab";$jc="Content-Type: multipart/mixed; boundary=\"$Aa\"";}$jc.=$Ab."MIME-Version: 1.0$Ab"."X-Mailer: Adminer Editor".($Zb?$Ab."From: ".str_replace("\n","",$Zb):"");return
mail($vb,email_header($qe),$xa.$C.$qa,$jc);}function
like_bool($k){return
preg_match("~bool|(tinyint|bit)\\(1\\)~",$k["full_type"]);}$f->select_db($b->database());$hd="RESTRICT|NO ACTION|CASCADE|SET NULL|SET DEFAULT";$ob[DRIVER]='Logga in';if(isset($_GET["select"])&&($_POST["edit"]||$_POST["clone"])&&!$_POST["save"])$_GET["edit"]=$_GET["select"];if(isset($_GET["download"])){$a=$_GET["download"];$l=fields($a);header("Content-Type: application/octet-stream");header("Content-Disposition: attachment; filename=".friendly_url("$a-".implode("_",$_GET["where"])).".".friendly_url($_GET["field"]));$O=array(idf_escape($_GET["field"]));$K=$i->select($a,$O,array(where($_GET,$l)),$O);$M=($K?$K->fetch_row():array());echo$i->value($M[0],$l[$_GET["field"]]);exit;}elseif(isset($_GET["edit"])){$a=$_GET["edit"];$l=fields($a);$Z=(isset($_GET["select"])?($_POST["check"]&&count($_POST["check"])==1?where_check($_POST["check"][0],$l):""):where($_GET,$l));$T=(isset($_GET["select"])?$_POST["edit"]:$Z);foreach($l
as$E=>$k){if(!isset($k["privileges"][$T?"update":"insert"])||$b->fieldName($k)==""||$k["generated"])unset($l[$E]);}if($_POST&&!$j&&!isset($_GET["select"])){$_=$_POST["referer"];if($_POST["insert"])$_=($T?null:$_SERVER["REQUEST_URI"]);elseif(!preg_match('~^.+&select=.+$~',$_))$_=ME."select=".urlencode($a);$u=indexes($a);$Se=unique_array($_GET["where"],$u);$Ld="\nWHERE $Z";if(isset($_POST["delete"]))queries_redirect($_,'En sak har tagits bort.',$i->delete($a,$Ld,!$Se));else{$Q=array();foreach($l
as$E=>$k){$W=process_input($k);if($W!==false&&$W!==null)$Q[idf_escape($E)]=$W;}if($T){if(!$Q)redirect($_);queries_redirect($_,'En sak har ändrats.',$i->update($a,$Q,$Ld,!$Se));if(is_ajax()){page_headers();page_messages($j);exit;}}else{$K=$i->insert($a,$Q);$Hc=($K?last_id():0);queries_redirect($_,sprintf('Sak%s har skapats.',($Hc?" $Hc":"")),$K);}}}$M=null;if($_POST["save"])$M=(array)$_POST["fields"];elseif($Z){$O=array();foreach($l
as$E=>$k){if(isset($k["privileges"]["select"])){$oa=convert_field($k);if($_POST["clone"]&&$k["auto_increment"])$oa="''";if($w=="sql"&&preg_match("~enum|set~",$k["type"]))$oa="1*".idf_escape($E);$O[]=($oa?"$oa AS ":"").idf_escape($E);}}$M=array();if(!support("table"))$O=array("*");if($O){$K=$i->select($a,$O,array($Z),$O,array(),(isset($_GET["select"])?2:1));if(!$K)$j=error();else{$M=$K->fetch_assoc();if(!$M)$M=false;}if(isset($_GET["select"])&&(!$M||$K->fetch_assoc()))$M=null;}}if(!support("table")&&!$l){if(!$Z){$K=$i->select($a,array("*"),$Z,array("*"));$M=($K?$K->fetch_assoc():false);if(!$M)$M=array($i->primary=>"");}if($M){foreach($M
as$x=>$W){if(!$Z)$M[$x]=null;$l[$x]=array("field"=>$x,"null"=>($x!=$i->primary),"auto_increment"=>($x==$i->primary));}}}edit_form($a,$l,$M,$T);}elseif(isset($_GET["select"])){$a=$_GET["select"];$we=table_status1($a);$u=indexes($a);$l=fields($a);$Wb=column_foreign_keys($a);$gd=$we["Oid"];parse_str($_COOKIE["adminer_import"],$ja);$Ud=array();$e=array();$Ae=null;foreach($l
as$x=>$k){$E=$b->fieldName($k);if(isset($k["privileges"]["select"])&&$E!=""){$e[$x]=html_entity_decode(strip_tags($E),ENT_QUOTES);if(is_shortable($k))$Ae=$b->selectLengthProcess();}$Ud+=$k["privileges"];}list($O,$q)=$b->selectColumnsProcess($e,$u);$v=count($q)<count($O)||strstr($O[0],"DISTINCT");$Z=$b->selectSearchProcess($l,$u);$G=$b->selectOrderProcess($l,$u);$y=$b->selectLimitProcess();if($_GET["val"]&&is_ajax()){header("Content-Type: text/plain; charset=utf-8");foreach($_GET["val"]as$Te=>$M){$oa=convert_field($l[key($M)]);$O=array($oa?$oa:idf_escape(key($M)));$Z[]=where_check($Te,$l);$L=$i->select($a,$O,$Z,$O);if($L)echo
reset($L->fetch_row());}exit;}$Ed=$Ve=null;foreach($u
as$t){if($t["type"]=="PRIMARY"){$Ed=array_flip($t["columns"]);$Ve=($O?$Ed:array());foreach($Ve
as$x=>$W){if(in_array(idf_escape($x),$O))unset($Ve[$x]);}break;}}if($gd&&!$Ed){$Ed=$Ve=array($gd=>0);$u[]=array("type"=>"PRIMARY","columns"=>array($gd));}if($_POST&&!$j){$hf=$Z;if(!$_POST["all"]&&is_array($_POST["check"])){$Ea=array();foreach($_POST["check"]as$Ca)$Ea[]=where_check($Ca,$l);$hf[]="((".implode(") OR (",$Ea)."))";}$hf=($hf?"\nWHERE ".implode(" AND ",$hf):"");if($_POST["export"]){cookie("adminer_import","output=".urlencode($_POST["output"])."&format=".urlencode($_POST["format"]));dump_headers($a);$b->dumpTable($a,"");$Zb=($O?implode(", ",$O):"*").convert_fields($e,$l,$O)."\nFROM ".table($a);$cc=($q&&$v?"\nGROUP BY ".implode(", ",$q):"").($G?"\nORDER BY ".implode(", ",$G):"");if(!is_array($_POST["check"])||$Ed)$J="SELECT $Zb$hf$cc";else{$Re=array();foreach($_POST["check"]as$W)$Re[]="(SELECT".limit($Zb,"\nWHERE ".($Z?implode(" AND ",$Z)." AND ":"").where_check($W,$l).$cc,1).")";$J=implode(" UNION ALL ",$Re);}$b->dumpData($a,"table",$J);exit;}if(!$b->selectEmailProcess($Z,$Wb)){if($_POST["save"]||$_POST["delete"]){$K=true;$ka=0;$Q=array();if(!$_POST["delete"]){foreach($e
as$E=>$W){$W=process_input($l[$E]);if($W!==null&&($_POST["clone"]||$W!==false))$Q[idf_escape($E)]=($W!==false?$W:idf_escape($E));}}if($_POST["delete"]||$Q){if($_POST["clone"])$J="INTO ".table($a)." (".implode(", ",array_keys($Q)).")\nSELECT ".implode(", ",$Q)."\nFROM ".table($a);if($_POST["all"]||($Ed&&is_array($_POST["check"]))||$v){$K=($_POST["delete"]?$i->delete($a,$hf):($_POST["clone"]?queries("INSERT $J$hf"):$i->update($a,$Q,$hf)));$ka=$f->affected_rows;}else{foreach((array)$_POST["check"]as$W){$gf="\nWHERE ".($Z?implode(" AND ",$Z)." AND ":"").where_check($W,$l);$K=($_POST["delete"]?$i->delete($a,$gf,1):($_POST["clone"]?queries("INSERT".limit1($a,$J,$gf)):$i->update($a,$Q,$gf,1)));if(!$K)break;$ka+=$f->affected_rows;}}}$C=lang(array('%d sak har blivit förändrad.','%d saker har blivit förändrade.'),$ka);if($_POST["clone"]&&$K&&$ka==1){$Hc=last_id();if($Hc)$C=sprintf('Sak%s har skapats.'," $Hc");}queries_redirect(remove_from_uri($_POST["all"]&&$_POST["delete"]?"page":""),$C,$K);if(!$_POST["delete"]){edit_form($a,$l,(array)$_POST["fields"],!$_POST["clone"]);page_footer();exit;}}elseif(!$_POST["import"]){if(!$_POST["val"])$j='Ctrl+klicka på ett värde för att ändra det.';else{$K=true;$ka=0;foreach($_POST["val"]as$Te=>$M){$Q=array();foreach($M
as$x=>$W){$x=bracket_escape($x,1);$Q[idf_escape($x)]=(preg_match('~char|text~',$l[$x]["type"])||$W!=""?$b->processInput($l[$x],$W):"NULL");}$K=$i->update($a,$Q," WHERE ".($Z?implode(" AND ",$Z)." AND ":"").where_check($Te,$l),!$v&&!$Ed," ");if(!$K)break;$ka+=$f->affected_rows;}queries_redirect(remove_from_uri(),lang(array('%d sak har blivit förändrad.','%d saker har blivit förändrade.'),$ka),$K);}}elseif(!is_string($Mb=get_file("csv_file",true)))$j=upload_error($Mb);elseif(!preg_match('~~u',$Mb))$j='Filer måste vara i UTF-8-format.';else{cookie("adminer_import","output=".urlencode($ja["output"])."&format=".urlencode($_POST["separator"]));$K=true;$Ma=array_keys($l);preg_match_all('~(?>"[^"]*"|[^"\r\n]+)+~',$Mb,$B);$ka=count($B[0]);$i->begin();$de=($_POST["separator"]=="csv"?",":($_POST["separator"]=="tsv"?"\t":";"));$N=array();foreach($B[0]as$x=>$W){preg_match_all("~((?>\"[^\"]*\")+|[^$de]*)$de~",$W.$de,$Rc);if(!$x&&!array_diff($Rc[1],$Ma)){$Ma=$Rc[1];$ka--;}else{$Q=array();foreach($Rc[1]as$r=>$Ja)$Q[idf_escape($Ma[$r])]=($Ja==""&&$l[$Ma[$r]]["null"]?"NULL":q(str_replace('""','"',preg_replace('~^"|"$~','',$Ja))));$N[]=$Q;}}$K=(!$N||$i->insertUpdate($a,$N,$Ed));if($K)$K=$i->commit();queries_redirect(remove_from_uri("page"),lang(array('%d rad har importerats.','%d rader har importerats.'),$ka),$K);$i->rollback();}}}$ve=$b->tableName($we);if(is_ajax()){page_headers();ob_start();}else
page_header('Välj'.": $ve",$j);$Q=null;if(isset($Ud["insert"])||!support("table")){$Q="";foreach((array)$_GET["where"]as$W){if($Wb[$W["col"]]&&count($Wb[$W["col"]])==1&&($W["op"]=="="||(!$W["op"]&&!preg_match('~[_%]~',$W["val"]))))$Q.="&set".urlencode("[".bracket_escape($W["col"])."]")."=".urlencode($W["val"]);}}$b->selectLinks($we,$Q);if(!$e&&support("table"))echo"<p class='error'>".'Kunde inte välja tabellen'.($l?".":": ".error())."\n";else{echo"<form action='' id='form'>\n","<div style='display: none;'>";hidden_fields_get();echo(DB!=""?'<input type="hidden" name="db" value="'.h(DB).'">'.(isset($_GET["ns"])?'<input type="hidden" name="ns" value="'.h($_GET["ns"]).'">':""):"");echo'<input type="hidden" name="select" value="'.h($a).'">','<input type="submit" value="'.h('Välj').'">';echo"</div>\n";$b->selectColumnsPrint($O,$e);$b->selectSearchPrint($Z,$e,$u);$b->selectOrderPrint($G,$e,$u);$b->selectLimitPrint($y);$b->selectLengthPrint($Ae);$b->selectActionPrint($u);echo"</form>\n";$H=$_GET["page"];if($H=="last"){$Yb=$f->result(count_rows($a,$Z,$v,$q));$H=floor(max(0,$Yb-1)/$y);}$Yd=$O;$bc=$q;if(!$Yd){$Yd[]="*";$Va=convert_fields($e,$l,$O);if($Va)$Yd[]=substr($Va,2);}foreach($O
as$x=>$W){$k=$l[idf_unescape($W)];if($k&&($oa=convert_field($k)))$Yd[$x]="$oa AS $W";}if(!$v&&$Ve){foreach($Ve
as$x=>$W){$Yd[]=idf_escape($x);if($bc)$bc[]=idf_escape($x);}}$K=$i->select($a,$Yd,$Z,$bc,$G,$y,$H,true);if(!$K)echo"<p class='error'>".error()."\n";else{if($w=="mssql"&&$H)$K->seek($y*$H);$xb=array();echo"<form action='' method='post' enctype='multipart/form-data'>\n";$N=array();while($M=$K->fetch_assoc()){if($H&&$w=="oracle")unset($M["RNUM"]);$N[]=$M;}if($_GET["page"]!="last"&&$y!=""&&$q&&$v&&$w=="sql")$Yb=$f->result(" SELECT FOUND_ROWS()");if(!$N)echo"<p class='message'>".'Inga rader.'."\n";else{$wa=$b->backwardKeys($a,$ve);echo"<div class='scrollable'>","<table id='table' cellspacing='0' class='nowrap checkable'>",script("mixin(qs('#table'), {onclick: tableClick, ondblclick: partialArg(tableClick, true), onkeydown: editingKeydown});"),"<thead><tr>".(!$q&&$O?"":"<td><input type='checkbox' id='all-page' class='jsonly'>".script("qs('#all-page').onclick = partial(formCheck, /check/);","")." <a href='".h($_GET["modify"]?remove_from_uri("modify"):$_SERVER["REQUEST_URI"]."&modify=1")."' title='".'Ändra'."' class='edit-all'>".'Ändra'."</a>");$ad=array();$ac=array();reset($O);$Nd=1;foreach($N[0]as$x=>$W){if(!isset($Ve[$x])){$W=$_GET["columns"][key($O)]??null;$k=$l[$O?($W?$W["col"]:current($O)):$x];$E=($k?$b->fieldName($k,$Nd):($W["fun"]?"*":$x));if($E!=""){$Nd++;$ad[$x]=$E;$d=idf_escape($x);$nc=remove_from_uri('(order|desc)[^=]*|page').'&order%5B0%5D='.urlencode($x);$ib="&desc%5B0%5D=1";echo"<th id='th[".h(bracket_escape($x))."]'>".script("mixin(qsl('th'), {onmouseover: partial(columnMouse), onmouseout: partial(columnMouse, ' hidden')});",""),'<a href="'.h($nc.($G[0]==$d||$G[0]==$x||(!$G&&$v&&$q[0]==$d)?$ib:'')).'">';echo
apply_sql_function($W["fun"]??null,$E)."</a>";echo"<span class='column hidden'>","<a href='".h($nc.$ib)."' title='".'Fallande'."' class='text'> ↓</a>";if(isset($W["fun"])===false){echo'<a href="#fieldset-search" title="'.'Sök'.'" class="text jsonly"> =</a>',script("qsl('a').onclick = partial(selectSearch, '".js_escape($x)."');");}echo"</span>";}$ac[$x]=$W["fun"]??null;next($O);}}$Kc=array();if($_GET["modify"]){foreach($N
as$M){foreach($M
as$x=>$W)$Kc[$x]=max($Kc[$x],min(40,strlen(utf8_decode($W))));}}echo($wa?"<th>".'Relationer':"")."</thead>\n";if(is_ajax()){if($y%2==1&&$H%2==1)odd();ob_end_clean();}foreach($b->rowDescriptions($N,$Wb)as$D=>$M){$Se=unique_array($N[$D],$u);if(!$Se){$Se=array();foreach($N[$D]as$x=>$W){if(!preg_match('~^(COUNT\((\*|(DISTINCT )?`(?:[^`]|``)+`)\)|(AVG|GROUP_CONCAT|MAX|MIN|SUM)\(`(?:[^`]|``)+`\))$~',$x))$Se[$x]=$W;}}$Te="";foreach($Se
as$x=>$W){if(($w=="sql"||$w=="pgsql")&&preg_match('~char|text|enum|set~',$l[$x]["type"])&&strlen($W)>64){$x=(strpos($x,'(')?$x:idf_escape($x));$x="MD5(".($w!='sql'||preg_match("~^utf8~",$l[$x]["collation"])?$x:"CONVERT($x USING ".charset($f).")").")";$W=md5($W);}$Te.="&".($W!==null?urlencode("where[".bracket_escape($x)."]")."=".urlencode($W===false?"f":$W):"null%5B%5D=".urlencode($x));}echo"<tr".odd().">".(!$q&&$O?"":"<td>".checkbox("check[]",substr($Te,1),in_array(substr($Te,1),(array)$_POST["check"])).($v||information_schema(DB)?"":" <a href='".h(ME."edit=".urlencode($a).$Te)."' class='edit' title='".'redigera'."'>".'redigera'."</a>"));foreach($M
as$x=>$W){if(isset($ad[$x])){$k=$l[$x];$W=$i->value($W,$k);if($W!=""&&(!isset($xb[$x])||$xb[$x]!=""))$xb[$x]=(is_mail($W)?$ad[$x]:"");$z="";if(preg_match('~blob|bytea|raw|file~',$k["type"]??null)&&$W!="")$z=ME.'download='.urlencode($a).'&field='.urlencode($x).$Te;if(!$z&&$W!==null){foreach((array)$Wb[$x]as$n){if(count($Wb[$x])==1||end($n["source"])==$x){$z="";foreach($n["source"]as$r=>$ke)$z.=where_link($r,$n["target"][$r],$N[$D][$ke]);$z=($n["db"]!=""?preg_replace('~([?&]db=)[^&]+~','\1'.urlencode($n["db"]),ME):ME).'select='.urlencode($n["table"]).$z;if($n["ns"])$z=preg_replace('~([?&]ns=)[^&]+~','\1'.urlencode($n["ns"]),$z);if(count($n["source"])==1)break;}}}if($x=="COUNT(*)"){$z=ME."select=".urlencode($a);$r=0;foreach((array)$_GET["where"]as$V){if(!array_key_exists($V["col"],$Se))$z.=where_link($r++,$V["col"],$V["val"],$V["op"]);}foreach($Se
as$Ac=>$V)$z.=where_link($r++,$Ac,$V);}$W=select_value($W,$z,$k,$Ae);$s=h("val[$Te][".bracket_escape($x)."]");$X=null;if(isset($_POST["val"][$Te][bracket_escape($x)]))$_POST["val"][$Te][bracket_escape($x)];$tb=!is_array($M[$x])&&is_utf8($W)&&$N[$D][$x]==$M[$x]&&!$ac[$x];$_e=preg_match('~text|lob~',$k["type"]??null);echo"<td id='$s'";if(($_GET["modify"]&&$tb)||$X!==null){$ec=h($X!==null?$X:$M[$x]);echo">".($_e?"<textarea name='$s' cols='30' rows='".(substr_count($M[$x],"\n")+1)."'>$ec</textarea>":"<input name='$s' value='$ec' size='$Kc[$x]'>");}else{$Pc=strpos($W,"<i>…</i>");echo" data-text='".($Pc?2:($_e?1:0))."'".($tb?"":" data-warning='".h('Använd redigeringslänken för att ändra värdet.')."'").">$W</td>";}}}if($wa)echo"<td>";$b->backwardKeysPrint($wa,$N[$D]);echo"</tr>\n";}if(is_ajax())exit;echo"</table>\n","</div>\n";}if(!is_ajax()){if($N||$H){$Fb=true;if($_GET["page"]!="last"){if($y==""||(count($N)<$y&&($N||!$H)))$Yb=($H?$H*$y:0)+count($N);elseif($w!="sql"||!$v){$Yb=($v?false:found_rows($we,$Z));if($Yb<max(1e4,2*($H+1)*$y))$Yb=reset(slow_query(count_rows($a,$Z,$v,$q)));else$Fb=false;}}$td=($y!=""&&($Yb===false||$Yb>$y||$H));if($td){echo(($Yb===false?count($N)+1:$Yb-$H*$y)>$y?'<p><a href="'.h(remove_from_uri("page")."&page=".($H+1)).'" class="loadmore">'.'Ladda mer data'.'</a>'.script("qsl('a').onclick = partial(selectLoadMore, ".(+$y).", '".'Laddar'."…');",""):''),"\n";}}echo"<div class='footer'><div>\n";if($N||$H){if($td){$Sc=($Yb===false?$H+(count($N)>=$y?2:1):floor(($Yb-1)/$y));echo"<fieldset>";if($w!="simpledb"){echo"<legend><a href='".h(remove_from_uri("page"))."'>".'Sida'."</a></legend>",script("qsl('a').onclick = function () { pageClick(this.href, +prompt('".'Sida'."', '".($H+1)."')); return false; };"),pagination(0,$H).($H>5?" …":"");for($r=max(1,$H-4);$r<min($Sc,$H+5);$r++)echo
pagination($r,$H);if($Sc>0){echo($H+5<$Sc?" …":""),($Fb&&$Yb!==false?pagination($Sc,$H):" <a href='".h(remove_from_uri("page")."&page=last")."' title='~$Sc'>".'sist'."</a>");}}else{echo"<legend>".'Sida'."</legend>",pagination(0,$H).($H>1?" …":""),($H?pagination($H,$H):""),($Sc>$H?pagination($H+1,$H).($Sc>$H+1?" …":""):"");}echo"</fieldset>\n";}echo"<fieldset>","<legend>".'Hela resultatet'."</legend>";$mb=($Fb?"":"~ ").$Yb;echo
checkbox("all",1,0,($Yb!==false?($Fb?"":"~ ").lang(array('%d rad','%d rader'),$Yb):""),"var checked = formChecked(this, /check/); selectCount('selected', this.checked ? '$mb' : checked); selectCount('selected2', this.checked || !checked ? '$mb' : checked);")."\n","</fieldset>\n";if($b->selectCommandPrint()){echo'<fieldset',($_GET["modify"]?'':' class="jsonly"'),'><legend>Ändra</legend><div>
<input type="submit" value="Spara"',($_GET["modify"]?'':' title="'.'Ctrl+klicka på ett värde för att ändra det.'.'"'),'>
</div></fieldset>
<fieldset><legend>Vald <span id="selected"></span></legend><div>
<input type="submit" name="edit" value="Redigera">
<input type="submit" name="clone" value="Klona">
<input type="submit" name="delete" value="Ta bort">',confirm(),'</div></fieldset>
';}$Xb=$b->dumpFormat();foreach((array)$_GET["columns"]as$d){if($d["fun"]){unset($Xb['sql']);break;}}if($Xb){print_fieldset("export",'Exportera'." <span id='selected2'></span>");$rd=$b->dumpOutput();echo($rd?html_select("output",$rd,$ja["output"])." ":""),html_select("format",$Xb,$ja["format"])," <input type='submit' name='export' value='".'Exportera'."'>\n","</div></fieldset>\n";}$b->selectEmailPrint(array_filter($xb,'strlen'),$e);}echo"</div></div>\n";if($b->selectImportPrint()){echo"<div>","<a href='#import'>".'Importera'."</a>",script("qsl('a').onclick = partial(toggle, 'import');",""),"<span id='import' class='hidden'>: ","<input type='file' name='csv_file'> ",html_select("separator",array("csv"=>"CSV,","csv;"=>"CSV;","tsv"=>"TSV"),$ja["format"],1);echo" <input type='submit' name='import' value='".'Importera'."'>","</span>","</div>";}echo"<input type='hidden' name='token' value='$Je'>\n","</form>\n",(!$q&&$O?"":script("tableCheck();"));}}}if(is_ajax()){ob_end_clean();exit;}}elseif(isset($_GET["script"])){if($_GET["script"]=="kill")$f->query("KILL ".number($_POST["kill"]));elseif(list($S,$s,$E)=$b->_foreignColumn(column_foreign_keys($_GET["source"]),$_GET["field"])){$y=11;$K=$f->query("SELECT $s, $E FROM ".table($S)." WHERE ".(preg_match('~^[0-9]+$~',$_GET["value"])?"$s = $_GET[value] OR ":"")."$E LIKE ".q("$_GET[value]%")." ORDER BY 2 LIMIT $y");for($r=1;($M=$K->fetch_row())&&$r<$y;$r++)echo"<a href='".h(ME."edit=".urlencode($S)."&where".urlencode("[".bracket_escape(idf_unescape($s))."]")."=".urlencode($M[0]))."'>".h($M[1])."</a><br>\n";if($M)echo"...\n";}exit;}else{page_header('Server',"",false);if($b->homepage()){echo"<form action='' method='post'>\n","<p>".'Sök data i tabeller'.": <input type='search' name='query' value='".h($_POST["query"])."'> <input type='submit' value='".'Sök'."'>\n";if($_POST["query"]!="")search_tables();echo"<div class='scrollable'>\n","<table cellspacing='0' class='nowrap checkable'>\n",script("mixin(qsl('table'), {onclick: tableClick, ondblclick: partialArg(tableClick, true)});"),'<thead><tr class="wrap">','<td><input id="check-all" type="checkbox" class="jsonly">'.script("qs('#check-all').onclick = partial(formCheck, /^tables\[/);",""),'<th>'.'Tabell','<td>'.'Rader',"</thead>\n";foreach(table_status()as$S=>$M){$E=$b->tableName($M);if(isset($M["Engine"])&&$E!=""){echo'<tr'.odd().'><td>'.checkbox("tables[]",$S,in_array($S,(array)$_POST["tables"],true)),"<th><a href='".h(ME).'select='.urlencode($S)."'>$E</a>";$W=format_number($M["Rows"]);echo"<td align='right'><a href='".h(ME."edit=").urlencode($S)."'>".($M["Engine"]=="InnoDB"&&$W?"~ $W":$W)."</a>";}}echo"</table>\n","</div>\n","</form>\n",script("tableCheck();");}}page_footer();